// Emacs style mode select   -*- C++ -*- 
//-----------------------------------------------------------------------------
//
// $Id: info.c,v 1.44 1998/05/12 12:46:36 phares Exp $
//
// Copyright (C) 1993-1996 by id Software, Inc.
//
// This source is available for distribution and/or modification
// only under the terms of the DOOM Source Code License as
// published by id Software. All rights reserved.
//
// The source is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// FITNESS FOR A PARTICULAR PURPOSE. See the DOOM Source Code License
// for more details.
//
//
// DESCRIPTION:
//  Thing frame/state LUT,
//  generated by multigen utilitiy.
//  This one is the original DOOM version, preserved.
//  BOOM changes include commenting and addition of predefined lumps
//  for providing things that aren't in the IWAD without sending a
//  separate must-use wad file around with the EXE.
//
//-----------------------------------------------------------------------------

#pragma warning( disable : 4305 )
// ********************************************************************
// Predefined lumps
// ********************************************************************
// These are internally defined lumps, which can be overwritten in 
// a PWAD.  There were several things that needed these, such 
// as new menus, font characters, color maps, etc. and this
// is an easy way of incorporating them directly into the EXE rather
// than requiring that an ancillary file be carried around with it.
//
// Near the end of this section there is the actual list where the lumps
// are incorporated, and there it's easy to see explanations in context.

// killough 1/31/98: predefined lumps used to make up for wad deficiencies


// The digits themselves that are used in the HUD

const char dig0[]=  // zero
{
    5,  0,  7,  0,  0,  0,  0,  0,
   28,  0,  0,  0, 38,  0,  0,  0, 49,  0,  0,  0, 62,  0,  0,  0,
   73,  0,  0,  0,  1,  5,  0,176,176,176,176,176,  0,255,  1,  6,
    0,176,  0,  0,  0,176,  0,  0,255,  1,  2,  0,176,  0,  0,  5,
    2,  0,176,  0,  0,255,  1,  6,  0,176,176,176,176,176,  0,  0,
  255,  2,  5,  0,  0,  0,  0,  0,  0,  0,255,  0,  0,  0,  0,  0
};

static const char dig1[]=  // one
{
    5,  0,  7,  0,  0,  0,  0,  0,
   28,  0,  0,  0, 34,  0,  0,  0, 46,  0,  0,  0, 57,  0,  0,  0,
   67,  0,  0,  0,  5,  1,  0,176,  0,255,  1,  1,  0,176,  0,  5,
    2,  0,176,  0,  0,255,  1,  6,  0,176,176,176,176,176,  0,  0,
  255,  2,  5,  0,  0,  0,  0,176,  0,  0,255,  4,  3,  0,  0,  0,
    0,  0,255,  0,  0,  0,  0,  0
};

static const char dig2[]=  // two
{
    5,  0,  7,  0,  0,  0,  0,  0,
   28,  0,  0,  0, 41,  0,  0,  0, 52,  0,  0,  0, 63,  0,  0,  0,
   74,  0,  0,  0,  1,  1,  0,176,  0,  3,  3,  0,176,176,176,  0,
  255,  1,  6,  0,176,  0,176,  0,176,  0,  0,255,  1,  6,  0,176,
    0,176,  0,176,  0,  0,255,  1,  6,  0,176,176,176,  0,176,  0,
    0,255,  2,  3,  0,  0,  0,  0,  0,  6,  1,  0,  0,  0,255,  0
};

static const char dig3[]=  // three
{
    5,  0,  7,  0,  0,  0,  0,  0,
   28,  0,  0,  0, 41,  0,  0,  0, 55,  0,  0,  0, 69,  0,  0,  0,
   80,  0,  0,  0,  1,  2,  0,176,176,  0,  4,  2,  0,176,176,  0,
  255,  1,  3,  0,176,  0,  0,  0,  5,  2,  0,176,  0,  0,255,  1,
    3,  0,176,  0,176,  0,  5,  2,  0,176,  0,  0,255,  1,  6,  0,
  176,176,176,176,176,  0,  0,255,  2,  5,  0,  0,  0,  0,  0,  0,
    0,255,  0,  0,  0,  0,  0,  0
};

static const char dig4[]=  // four
{
    5,  0,  7,  0,  0,  0,  0,  0,
   28,  0,  0,  0, 37,  0,  0,  0, 46,  0,  0,  0, 57,  0,  0,  0,
   67,  0,  0,  0,  1,  4,  0,176,176,176,176,  0,255,  2,  4,  0,
    0,  0,176,  0,  0,255,  1,  6,  0,176,176,176,176,176,  0,  0,
  255,  2,  5,  0,  0,  0,176,  0,  0,  0,255,  4,  2,  0,  0,  0,
    0,255,
};

static const char dig45[]=  // minus '-'
{
    5,  0,  7,  0,  0,  0,  0,  0,
   28,  0,  0,  0, 29,  0,  0,  0, 35,  0,  0,  0, 42,  0,  0,  0,
   49,  0,  0,  0,255,  3,  1,  0,176,  0,255,  3,  2,  0,176,  0,
    0,255,  3,  2,  0,176,  0,  0,255,  4,  1,  0,  0,  0,255,  0
};


static const char dig47[]=  // slash '/'
{
    5,  0,  7,  0,  0,  0,  0,  0,
   28,  0,  0,  0, 29,  0,  0,  0, 36,  0,  0,  0, 43,  0,  0,  0,
   50,  0,  0,  0,255,  4,  2,  0,176,  0,  0,255,  3,  2,  0,176,
    0,  0,255,  2,  2,  0,176,  0,  0,255,255,  0,  0,  0,  0,  0
};

static const char dig5[]=  // five
{
    5,  0,  7,  0,  0,  0,  0,  0,
   28,  0,  0,  0, 41,  0,  0,  0, 52,  0,  0,  0, 63,  0,  0,  0,
   74,  0,  0,  0,  1,  3,  0,176,176,176,  0,  5,  1,  0,176,  0,
  255,  1,  6,  0,176,  0,176,  0,176,  0,  0,255,  1,  6,  0,176,
    0,176,  0,176,  0,  0,255,  1,  6,  0,176,  0,176,176,176,  0,
    0,255,  2,  5,  0,  0,  0,  0,  0,  0,  0,255,  0,  0,  0,  0
};

static const char dig58[]=  // colon ':'
{
    5,  0,  7,  0,  0,  0,  0,  0,
   28,  0,  0,  0, 29,  0,  0,  0, 30,  0,  0,  0, 41,  0,  0,  0,
   52,  0,  0,  0,255,255,  2,  1,  0,176,  0,  4,  1,  0,176,  0,
  255,  3,  1,  0,  0,  0,  5,  1,  0,  0,  0,255,255,  0,  0,  0
};

static const char dig6[]=  // six
{
    5,  0,  7,  0,  0,  0,  0,  0,
   28,  0,  0,  0, 38,  0,  0,  0, 49,  0,  0,  0, 60,  0,  0,  0,
   71,  0,  0,  0,  1,  5,  0,176,176,176,176,176,  0,255,  1,  6,
    0,176,  0,176,  0,176,  0,  0,255,  1,  6,  0,176,  0,176,  0,
  176,  0,  0,255,  1,  6,  0,176,  0,176,176,176,  0,  0,255,  2,
    5,  0,  0,  0,  0,  0,  0,  0,255,  0,  0,  0,  0,  0,  0,  0
};

static const char dig7[]=  // seven
{
    5,  0,  7,  0,  0,  0,  0,  0,
   28,  0,  0,  0, 34,  0,  0,  0, 41,  0,  0,  0, 51,  0,  0,  0,
   62,  0,  0,  0,  1,  1,  0,176,  0,255,  1,  2,  0,176,  0,  0,
  255,  1,  5,  0,176,  0,176,176,176,  0,255,  1,  6,  0,176,176,
    0,  0,  0,  0,  0,255,  2,  2,  0,  0,  0,  0,255,  0,  0,  0
};

static const char dig8[]=  // eight
{
    5,  0,  7,  0,  0,  0,  0,  0,
   28,  0,  0,  0, 38,  0,  0,  0, 49,  0,  0,  0, 60,  0,  0,  0,
   71,  0,  0,  0,  1,  5,  0,176,176,176,176,176,  0,255,  1,  6,
    0,176,  0,176,  0,176,  0,  0,255,  1,  6,  0,176,  0,176,  0,
  176,  0,  0,255,  1,  6,  0,176,176,176,176,176,  0,  0,255,  2,
    5,  0,  0,  0,  0,  0,  0,  0,255,  0,  0,  0,  0,  0,  0,  0
};

static const char dig9[]=  // nine
{
    5,  0,  7,  0,  0,  0,  0,  0,
   28,  0,  0,  0, 41,  0,  0,  0, 52,  0,  0,  0, 63,  0,  0,  0,
   74,  0,  0,  0,  1,  3,  0,176,176,176,  0,  5,  1,  0,176,  0,
  255,  1,  6,  0,176,  0,176,  0,176,  0,  0,255,  1,  6,  0,176,
    0,176,  0,176,  0,  0,255,  1,  6,  0,176,176,176,176,176,  0,
    0,255,  2,  5,  0,  0,  0,  0,  0,  0,  0,255,  0,  0,  0,  0
};

static const char dig91[]=  // open bracket '['
{
    5,  0,  7,  0,  0,  0,  0,  0,
   28,  0,  0,  0, 29,  0,  0,  0, 39,  0,  0,  0, 50,  0,  0,  0,
   61,  0,  0,  0,255,  1,  5,  0,176,176,176,176,176,  0,255,  1,
    6,  0,176,  0,  0,  0,176,  0,  0,255,  2,  1,  0,  0,  0,  6,
    1,  0,  0,  0,255,255,  0,  0
};

static const char dig93[]=  // close bracket ']'
{
    5,  0,  7,  0,  0,  0,  0,  0,
   28,  0,  0,  0, 29,  0,  0,  0, 40,  0,  0,  0, 51,  0,  0,  0,
   61,  0,  0,  0,255,  1,  1,  0,176,  0,  5,  1,  0,176,  0,255,
    1,  6,  0,176,176,176,176,176,  0,  0,255,  2,  5,  0,  0,  0,
    0,  0,  0,  0,255,255,  0,  0
};

static const char diga[]=  // these are the letters A-Z
{
    5,  0,  7,  0,  0,  0,  0,  0,
   28,  0,  0,  0, 38,  0,  0,  0, 49,  0,  0,  0, 58,  0,  0,  0,
   68,  0,  0,  0,  1,  5,  0,176,176,176,176,176,  0,255,  1,  6,
    0,176,  0,176,  0,  0,  0,  0,255,  1,  4,  0,176,  0,176,  0,
    0,255,  1,  5,  0,176,176,176,176,176,  0,255,  2,  5,  0,  0,
    0,  0,  0,  0,  0,255,  0,  0
};

static const char digb[]=
{
    5,  0,  7,  0,  0,  0,  0,  0,
   28,  0,  0,  0, 38,  0,  0,  0, 49,  0,  0,  0, 60,  0,  0,  0,
   70,  0,  0,  0,  1,  5,  0,176,176,176,176,176,  0,255,  1,  6,
    0,176,  0,176,  0,176,  0,  0,255,  1,  6,  0,176,176,176,  0,
  176,  0,  0,255,  2,  5,  0,  0,176,176,176,  0,  0,255,  3,  4,
    0,  0,  0,  0,  0,  0,255,  0
};

static const char digc[]=
{
    5,  0,  7,  0,  0,  0,  0,  0,
   28,  0,  0,  0, 38,  0,  0,  0, 49,  0,  0,  0, 62,  0,  0,  0,
   75,  0,  0,  0,  1,  5,  0,176,176,176,176,176,  0,255,  1,  6,
    0,176,  0,  0,  0,176,  0,  0,255,  1,  2,  0,176,  0,  0,  5,
    2,  0,176,  0,  0,255,  1,  2,  0,176,  0,  0,  5,  2,  0,176,
    0,  0,255,  2,  1,  0,  0,  0,  6,  1,  0,  0,  0,255,  0,  0
};

static const char digd[]=
{
    5,  0,  7,  0,  0,  0,  0,  0,
   28,  0,  0,  0, 38,  0,  0,  0, 49,  0,  0,  0, 62,  0,  0,  0,
   72,  0,  0,  0,  1,  5,  0,176,176,176,176,176,  0,255,  1,  6,
    0,176,  0,  0,  0,176,  0,  0,255,  1,  2,  0,176,  0,  0,  5,
    2,  0,176,  0,  0,255,  2,  5,  0,176,176,176,  0,  0,  0,255,
    3,  3,  0,  0,  0,  0,  0,255
};

static const char dige[]=
{
    5,  0,  7,  0,  0,  0,  0,  0,
   28,  0,  0,  0, 38,  0,  0,  0, 49,  0,  0,  0, 60,  0,  0,  0,
   74,  0,  0,  0,  1,  5,  0,176,176,176,176,176,  0,255,  1,  6,
    0,176,  0,176,  0,176,  0,  0,255,  1,  6,  0,176,  0,176,  0,
  176,  0,  0,255,  1,  2,  0,176,  0,  0,  4,  3,  0,  0,176,  0,
    0,255,  2,  1,  0,  0,  0,  6,  1,  0,  0,  0,255,  0,  0,  0
};

static const char digf[]=
{
    5,  0,  7,  0,  0,  0,  0,  0,
   28,  0,  0,  0, 38,  0,  0,  0, 49,  0,  0,  0, 58,  0,  0,  0,
   70,  0,  0,  0,  1,  5,  0,176,176,176,176,176,  0,255,  1,  6,
    0,176,  0,176,  0,  0,  0,  0,255,  1,  4,  0,176,  0,176,  0,
    0,255,  1,  2,  0,176,  0,  0,  4,  1,  0,  0,  0,255,  2,  1,
    0,  0,  0,255,  0,  0,  0,  0
};

static const char digg[]=
{
    5,  0,  7,  0,  0,  0,  0,  0,
   28,  0,  0,  0, 38,  0,  0,  0, 49,  0,  0,  0, 63,  0,  0,  0,
   74,  0,  0,  0,  1,  5,  0,176,176,176,176,176,  0,255,  1,  6,
    0,176,  0,  0,  0,176,  0,  0,255,  1,  3,  0,176,  0,176,  0,
    5,  2,  0,176,  0,  0,255,  1,  6,  0,176,  0,176,176,176,  0,
    0,255,  2,  1,  0,  0,  0,  4,  3,  0,  0,  0,  0,  0,255,  0
};

static const char digh[]=
{
    5,  0,  7,  0,  0,  0,  0,  0,
   28,  0,  0,  0, 38,  0,  0,  0, 48,  0,  0,  0, 55,  0,  0,  0,
   65,  0,  0,  0,  1,  5,  0,176,176,176,176,176,  0,255,  2,  5,
    0,  0,176,  0,  0,  0,  0,255,  3,  2,  0,176,  0,  0,255,  1,
    5,  0,176,176,176,176,176,  0,255,  2,  5,  0,  0,  0,  0,  0,
    0,  0,255,  0,  0,  0,  0,  0
};

static const char digi[]=
{
    5,  0,  7,  0,  0,  0,  0,  0,
   28,  0,  0,  0, 29,  0,  0,  0, 40,  0,  0,  0, 51,  0,  0,  0,
   62,  0,  0,  0,255,  1,  1,  0,176,  0,  5,  1,  0,176,  0,255,
    1,  6,  0,176,176,176,176,176,  0,  0,255,  1,  6,  0,176,  0,
    0,  0,176,  0,  0,255,  5,  2,  0,  0,  0,  0,255,  0,  0,  0
};

static const char digj[]=
{
    5,  0,  7,  0,  0,  0,  0,  0,
   28,  0,  0,  0, 40,  0,  0,  0, 53,  0,  0,  0, 64,  0,  0,  0,
   75,  0,  0,  0,  1,  1,  0,176,  0,  4,  2,  0,176,176,  0,255,
    1,  2,  0,176,  0,  0,  5,  2,  0,176,  0,  0,255,  1,  6,  0,
  176,176,176,176,176,  0,  0,255,  1,  6,  0,176,  0,  0,  0,  0,
    0,  0,255,  2,  1,  0,  0,  0,255,  0,  0,  0,  0,  0,  0,  0
};

static const char digk[]=
{
    5,  0,  7,  0,  0,  0,  0,  0,
   28,  0,  0,  0, 38,  0,  0,  0, 48,  0,  0,  0, 57,  0,  0,  0,
   68,  0,  0,  0,  1,  5,  0,176,176,176,176,176,  0,255,  2,  5,
    0,  0,176,  0,  0,  0,  0,255,  1,  4,  0,176,176,176,  0,  0,
  255,  1,  6,  0,176,  0,176,176,176,  0,  0,255,  2,  1,  0,  0,
    0,  4,  3,  0,  0,  0,  0,  0,255,  0,  0,  0,  0,  0,  0,  0
};

static const char digl[]=
{
    5,  0,  7,  0,  0,  0,  0,  0,
   28,  0,  0,  0, 38,  0,  0,  0, 48,  0,  0,  0, 55,  0,  0,  0,
   62,  0,  0,  0,  1,  5,  0,176,176,176,176,176,  0,255,  2,  5,
    0,  0,  0,  0,176,  0,  0,255,  5,  2,  0,176,  0,  0,255,  5,
    2,  0,176,  0,  0,255,  6,  1,  0,  0,  0,255,  0,  0,  0,  0
};

static const char digm[]=
{
    5,  0,  7,  0,  0,  0,  0,  0,
   28,  0,  0,  0, 38,  0,  0,  0, 48,  0,  0,  0, 56,  0,  0,  0,
   66,  0,  0,  0,  1,  5,  0,176,176,176,176,176,  0,255,  2,  5,
    0,176,176,  0,  0,  0,  0,255,  2,  3,  0,176,176,  0,  0,255,
    1,  5,  0,176,176,176,176,176,  0,255,  2,  5,  0,  0,  0,  0,
    0,  0,  0,255,  0,  0,  0,  0
};

static const char dign[]=
{
    5,  0,  7,  0,  0,  0,  0,  0,
   28,  0,  0,  0, 38,  0,  0,  0, 48,  0,  0,  0, 55,  0,  0,  0,
   65,  0,  0,  0,  1,  5,  0,176,176,176,176,176,  0,255,  2,  5,
    0,176,176,  0,  0,  0,  0,255,  3,  2,  0,176,176,  0,255,  1,
    5,  0,176,176,176,176,176,  0,255,  2,  5,  0,  0,  0,  0,  0,
    0,  0,255,  0,  0,  0,  0,  0
};

static const char digo[]=
{
    5,  0,  7,  0,  0,  0,  0,  0,
   28,  0,  0,  0, 38,  0,  0,  0, 49,  0,  0,  0, 62,  0,  0,  0,
   73,  0,  0,  0,  1,  5,  0,176,176,176,176,176,  0,255,  1,  6,
    0,176,  0,  0,  0,176,  0,  0,255,  1,  2,  0,176,  0,  0,  5,
    2,  0,176,  0,  0,255,  1,  6,  0,176,176,176,176,176,  0,  0,
  255,  2,  5,  0,  0,  0,  0,  0,  0,  0,255,  0,  0,  0,  0,  0
};

static const char digp[]=
{
    5,  0,  7,  0,  0,  0,  0,  0,
   28,  0,  0,  0, 38,  0,  0,  0, 49,  0,  0,  0, 58,  0,  0,  0,
   67,  0,  0,  0,  1,  5,  0,176,176,176,176,176,  0,255,  1,  6,
    0,176,  0,176,  0,  0,  0,  0,255,  1,  4,  0,176,  0,176,  0,
    0,255,  1,  4,  0,176,176,176,  0,  0,255,  2,  3,  0,  0,  0,
    0,  0,255,  0,  0,  0,  0,  0
};

static const char digq[]=
{
    5,  0,  7,  0,  0,  0,  0,  0,
   28,  0,  0,  0, 38,  0,  0,  0, 49,  0,  0,  0, 63,  0,  0,  0,
   74,  0,  0,  0,  1,  5,  0,176,176,176,176,176,  0,255,  1,  6,
    0,176,  0,  0,176,176,  0,  0,255,  1,  2,  0,176,  0,  0,  4,
    3,  0,  0,176,176,  0,255,  1,  6,  0,176,176,176,176,176,  0,
    0,255,  2,  5,  0,  0,  0,  0,  0,  0,  0,255,  0,  0,  0,  0
};

static const char digr[]=
{
    5,  0,  7,  0,  0,  0,  0,  0,
   28,  0,  0,  0, 38,  0,  0,  0, 49,  0,  0,  0, 58,  0,  0,  0,
   67,  0,  0,  0,  1,  5,  0,176,176,176,176,176,  0,255,  1,  6,
    0,176,  0,176,  0,  0,  0,  0,255,  1,  4,  0,176,176,176,  0,
    0,255,  2,  4,  0,  0,176,176,176,  0,255,  3,  4,  0,  0,  0,
    0,  0,  0,255,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
};

static const char digs[]=
{
    5,  0,  7,  0,  0,  0,  0,  0,
   28,  0,  0,  0, 41,  0,  0,  0, 52,  0,  0,  0, 63,  0,  0,  0,
   74,  0,  0,  0,  1,  3,  0,176,176,176,  0,  5,  1,  0,176,  0,
  255,  1,  6,  0,176,  0,176,  0,176,  0,  0,255,  1,  6,  0,176,
    0,176,  0,176,  0,  0,255,  1,  6,  0,176,  0,176,176,176,  0,
    0,255,  2,  5,  0,  0,  0,  0,  0,  0,  0,255,  0,  0,  0,  0
};

static const char digt[]=
{
    5,  0,  7,  0,  0,  0,  0,  0,
   28,  0,  0,  0, 34,  0,  0,  0, 41,  0,  0,  0, 51,  0,  0,  0,
   62,  0,  0,  0,  1,  1,  0,176,  0,255,  1,  2,  0,176,  0,  0,
  255,  1,  5,  0,176,176,176,176,176,  0,255,  1,  6,  0,176,  0,
    0,  0,  0,  0,  0,255,  2,  1,  0,  0,  0,255,  0,  0,  0,  0
};

static const char digu[]=
{
    5,  0,  7,  0,  0,  0,  0,  0,
   28,  0,  0,  0, 38,  0,  0,  0, 48,  0,  0,  0, 55,  0,  0,  0,
   66,  0,  0,  0,  1,  5,  0,176,176,176,176,176,  0,255,  2,  5,
    0,  0,  0,  0,176,  0,  0,255,  5,  2,  0,176,  0,  0,255,  1,
    6,  0,176,176,176,176,176,  0,  0,255,  2,  5,  0,  0,  0,  0,
    0,  0,  0,255,
};

static const char digv[]=
{
    5,  0,  7,  0,  0,  0,  0,  0,
   28,  0,  0,  0, 36,  0,  0,  0, 45,  0,  0,  0, 53,  0,  0,  0,
   64,  0,  0,  0,  1,  3,  0,176,176,176,  0,255,  2,  4,  0,  0,
    0,176,176,  0,255,  4,  3,  0,176,176,  0,  0,255,  1,  6,  0,
  176,176,176,  0,  0,  0,  0,255,  2,  3,  0,  0,  0,  0,  0,255
};

static const char digw[]=
{
    5,  0,  7,  0,  0,  0,  0,  0,
   28,  0,  0,  0, 38,  0,  0,  0, 47,  0,  0,  0, 56,  0,  0,  0,
   67,  0,  0,  0,  1,  5,  0,176,176,176,176,176,  0,255,  3,  4,
    0,176,176,  0,  0,  0,255,  3,  4,  0,176,176,  0,  0,  0,255,
    1,  6,  0,176,176,176,176,176,  0,  0,255,  2,  5,  0,  0,  0,
    0,  0,  0,  0,255,  0,  0,  0
};

static const char digx[]=
{
    5,  0,  7,  0,  0,  0,  0,  0,
   28,  0,  0,  0, 41,  0,  0,  0, 51,  0,  0,  0, 60,  0,  0,  0,
   71,  0,  0,  0,  1,  2,  0,176,176,  0,  4,  2,  0,176,176,  0,
  255,  2,  5,  0,176,176,176,  0,  0,  0,255,  2,  4,  0,176,176,
  176,  0,  0,255,  1,  6,  0,176,176,  0,176,176,  0,  0,255,  2,
    5,  0,  0,  0,  0,  0,  0,  0,255,  0,  0,  0,  0,  0,  0,  0
};

static const char digy[]=
{
    5,  0,  7,  0,  0,  0,  0,  0,
   28,  0,  0,  0, 42,  0,  0,  0, 52,  0,  0,  0, 61,  0,  0,  0,
   72,  0,  0,  0,  1,  3,  0,176,176,176,  0,  5,  2,  0,176,  0,
    0,255,  2,  5,  0,  0,176,  0,176,  0,  0,255,  3,  4,  0,176,
    0,176,  0,  0,255,  1,  6,  0,176,176,176,176,176,  0,  0,255,
    2,  5,  0,  0,  0,  0,  0,  0,  0,255,  0,  0,  0,  0,  0,  0
};

static const char digz[]=  // end of letters A-Z
{
    5,  0,  7,  0,  0,  0,  0,  0,
   28,  0,  0,  0, 40,  0,  0,  0, 51,  0,  0,  0, 62,  0,  0,  0,
   73,  0,  0,  0,  1,  1,  0,176,  0,  4,  2,  0,176,176,  0,255,
    1,  6,  0,176,  0,176,176,176,  0,  0,255,  1,  6,  0,176,176,
  176,  0,176,  0,  0,255,  1,  6,  0,176,176,  0,  0,176,  0,  0,
  255,  2,  2,  0,  0,  0,  0,  6,  1,  0,  0,  0,255,  0,  0,  0
};

static const char stkeys6[]=  // show both blue keys on stat bar
{
    7,  0,  7,  0,  0,  0,  0,  0,
   36,  0,  0,  0, 43,  0,  0,  0, 51,  0,  0,  0, 62,  0,  0,  0,
   74,  0,  0,  0, 86,  0,  0,  0, 96,  0,  0,  0,  1,  2,  0,198,
  200,  0,255,  0,  3,  0,198,202,203,  0,255,  0,  6,  0,198,  0,
  202,204,199,197,  0,255,  0,  7,  0,198,202,202,198,207,199,203,
    0,255,  0,  7,  0,200,  0,201,199,200,207,202,  0,255,  2,  5,
    0,202,199,207,199,202,  0,255,  3,  3,  0,204,199,197,  0,255
};

static const char stkeys7[]=  // show both yellow keys on stat bar
{
    7,  0,  7,  0,  0,  0,  0,  0,
   36,  0,  0,  0, 43,  0,  0,  0, 51,  0,  0,  0, 62,  0,  0,  0,
   74,  0,  0,  0, 86,  0,  0,  0, 96,  0,  0,  0,  1,  2,  0,161,
  161,  0,255,  0,  3,  0,161,163,163,  0,255,  0,  6,  0,161,  0,
  163,220,162,235,  0,255,  0,  7,  0,161,163,217,162,246,214,221,
    0,255,  0,  7,  0,161,  0,214,213,214,246,218,  0,255,  2,  5,
    0,217,162,246,214,221,  0,255,  3,  3,  0,220,162,235,  0,255
};

static const char stkeys8[]=  // show both red keys on stat bar
{
    7,  0,  7,  0,  0,  0,  0,  0,
   36,  0,  0,  0, 43,  0,  0,  0, 51,  0,  0,  0, 62,  0,  0,  0,
   74,  0,  0,  0, 86,  0,  0,  0, 96,  0,  0,  0,  1,  2,  0,174,
  176,  0,255,  0,  3,  0,174,179,179,  0,255,  0,  6,  0,176,  0,
  179,184,174,174,  0,255,  0,  7,  0,176,179,185,175,246,185,182,
    0,255,  0,  7,  0,176,  0,183,177,176,246,179,  0,255,  2,  5,
    0,185,177,246,185,182,  0,255,  3,  3,  0,185,175,174,  0,255
};

// Background characters for the message review when enabled
// Makes a general purpose background box, could be used for other
// purposes as well
//
//  ul uc ur
//  cl cc cr
//  ll lc lr
//

static const char boxcc[]=  // message background characters
{
    8,  0,  8,  0,  0,  0,  0,  0,
   40,  0,  0,  0, 53,  0,  0,  0, 66,  0,  0,  0, 79,  0,  0,  0,
   92,  0,  0,  0,105,  0,  0,  0,118,  0,  0,  0,131,  0,  0,  0,
    0,  8,  0,151,151,151, 77, 77, 77, 78, 77,  0,255,  0,  8,  0,
   77, 77, 78, 77, 77, 77, 77, 78,  0,255,  0,  8,  0, 78,151, 77,
   78, 78, 77, 78, 77,  0,255,  0,  8,  0, 77, 77, 78, 77, 77, 77,
   77,151,  0,255,  0,  8,  0,151, 77, 77,151, 77, 78, 77, 77,  0,
  255,  0,  8,  0, 77, 78, 77, 77, 77, 77,151, 78,  0,255,  0,  8,
    0, 78, 77, 77,151, 77, 78, 77, 77,  0,255,  0,  8,  0, 77, 78,
   77, 77, 77,151,151,151,  0,255
};

static const char boxcl[]=
{
    8,  0,  8,  0,  0,  0,  0,  0,
   40,  0,  0,  0, 53,  0,  0,  0, 66,  0,  0,  0, 79,  0,  0,  0,
   92,  0,  0,  0,105,  0,  0,  0,118,  0,  0,  0,131,  0,  0,  0,
    0,  8,  0, 10, 10,  9, 10,  9,  9, 10,  9,  0,255,  0,  8,  0,
   11,126,126,126,126, 11,126,126,  0,255,  0,  8,  0,238,238,238,
  238,238,238,238,238,  0,255,  0,  8,  0,151,151, 76, 77,151,151,
  151,151,  0,255,  0,  8,  0,151, 76,151,151,151, 77,151,151,  0,
  255,  0,  8,  0,151,151,151, 77, 77,151, 78,151,  0,255,  0,  8,
    0, 77, 78, 77, 77, 78, 77,151, 77,  0,255,  0,  8,  0,151,151,
   77, 77, 77, 77, 78, 78,  0,255
};

static const char boxcr[]=
{
    8,  0,  8,  0,  0,  0,  0,  0,
   40,  0,  0,  0, 53,  0,  0,  0, 66,  0,  0,  0, 79,  0,  0,  0,
   92,  0,  0,  0,105,  0,  0,  0,118,  0,  0,  0,131,  0,  0,  0,
    0,  8,  0, 78, 78, 77,151,151, 77,151,151,  0,255,  0,  8,  0,
   77,151, 77,151, 77, 77, 78, 77,  0,255,  0,  8,  0,151, 78,151,
   76,151,151,151,151,  0,255,  0,  8,  0,151,151, 77, 76, 76,151,
   76,151,  0,255,  0,  8,  0,151,151,151,151, 76, 76,151,151,  0,
  255,  0,  8,  0,238,238,238,238,238,238,238,238,  0,255,  0,  8,
    0, 11,126,126,126,126, 11,126,126,  0,255,  0,  8,  0, 10, 10,
    9, 10,  9,  9, 10,  9,  0,255
};

static const char boxlc[]=
{
    8,  0,  8,  0,  0,  0,  0,  0,
   40,  0,  0,  0, 53,  0,  0,  0, 66,  0,  0,  0, 79,  0,  0,  0,
   92,  0,  0,  0,105,  0,  0,  0,118,  0,  0,  0,131,  0,  0,  0,
    0,  8,  0, 77, 77, 77, 78, 77,  9,  9, 11,  0,255,  0,  8,  0,
   77, 77, 77, 77, 78,159, 10,126,  0,255,  0,  8,  0, 78, 78, 77,
   78, 77,  9,  9,126,  0,255,  0,  8,  0, 77, 77, 77, 77,151,159,
   10, 11,  0,255,  0,  8,  0,151, 77, 78, 77, 77,  9, 10,126,  0,
  255,  0,  8,  0, 77, 77, 77,151, 78,  9,  9,126,  0,255,  0,  8,
    0,151, 77, 78, 77, 77,159, 10,126,  0,255,  0,  8,  0, 77, 77,
  151,151,151,159,  9,126,  0,255
};

static const char boxll[]=
{
    8,  0,  8,  0,  0,  0,  0,  0,
   40,  0,  0,  0, 53,  0,  0,  0, 66,  0,  0,  0, 79,  0,  0,  0,
   92,  0,  0,  0,105,  0,  0,  0,118,  0,  0,  0,131,  0,  0,  0,
    0,  8,  0, 10,  9,  9, 10,  9, 10,  9, 10,  0,255,  0,  8,  0,
  126,126, 11,126,126,126, 10, 11,  0,255,  0,  8,  0,238,238,238,
  238,238, 10, 10,126,  0,255,  0,  8,  0, 77,151,151,151,151,159,
   10, 11,  0,255,  0,  8,  0,151,151, 77,151,151,  9, 10,126,  0,
  255,  0,  8,  0, 77, 77,151, 78,151,  9,  9,126,  0,255,  0,  8,
    0, 77, 78, 77,151, 77,159, 10,126,  0,255,  0,  8,  0, 77, 77,
   77, 78, 78,159,  9,126,  0,255
};

static const char boxlr[]=
{
    8,  0,  8,  0,  0,  0,  0,  0,
   40,  0,  0,  0, 53,  0,  0,  0, 66,  0,  0,  0, 79,  0,  0,  0,
   92,  0,  0,  0,105,  0,  0,  0,118,  0,  0,  0,131,  0,  0,  0,
    0,  8,  0,151,151, 77,151,151,  9,  9, 11,  0,255,  0,  8,  0,
  151, 77, 77, 78, 77,159, 10,126,  0,255,  0,  8,  0, 76,151,151,
  151,151,  9,  9,126,  0,255,  0,  8,  0, 76, 76,151, 76,151,159,
   10,126,  0,255,  0,  8,  0,151, 76, 76,151,151,  9,  9,126,  0,
  255,  0,  8,  0,238,238,238,238,238,  9, 10,126,  0,255,  0,  8,
    0,126,126, 11,126,126,126, 10, 11,  0,255,  0,  8,  0, 10,  9,
    9, 10,  9, 10,  9, 10,  0,255
};

static const char boxuc[]=
{
    8,  0,  8,  0,  0,  0,  0,  0,
   40,  0,  0,  0, 53,  0,  0,  0, 66,  0,  0,  0, 79,  0,  0,  0,
   92,  0,  0,  0,105,  0,  0,  0,118,  0,  0,  0,131,  0,  0,  0,
    0,  8,  0,  9, 11,239,151,151,151, 77, 77,  0,255,  0,  8,  0,
   10,126,239, 77, 77, 78, 77, 77,  0,255,  0,  8,  0,  9,126,239,
   78,151, 77, 78, 78,  0,255,  0,  8,  0, 10, 11,239, 77, 77, 78,
   77, 77,  0,255,  0,  8,  0, 10,126,239,151, 77, 77,151, 77,  0,
  255,  0,  8,  0,  9,126,239, 77, 78, 77, 77, 77,  0,255,  0,  8,
    0, 10,126,239, 78, 77, 77,151, 77,  0,255,  0,  8,  0,  9,126,
  239, 77, 78, 77, 77, 77,  0,255
};

static const char boxul[]=
{
    8,  0,  8,  0,  0,  0,  0,  0,
   40,  0,  0,  0, 53,  0,  0,  0, 66,  0,  0,  0, 79,  0,  0,  0,
   92,  0,  0,  0,105,  0,  0,  0,118,  0,  0,  0,131,  0,  0,  0,
    0,  8,  0,159, 10, 10, 10, 10,  9, 10,  9,  0,255,  0,  8,  0,
   10, 11,126, 11,126,126,126,126,  0,255,  0,  8,  0, 10,126,239,
  238,238,238,238,238,  0,255,  0,  8,  0, 10, 11,239,151,151, 76,
   77,151,  0,255,  0,  8,  0, 10,126,239,151, 76,151,151,151,  0,
  255,  0,  8,  0,  9,126,239,151,151,151, 77, 77,  0,255,  0,  8,
    0, 10,126,239, 77, 78, 77, 77, 78,  0,255,  0,  8,  0,  9,126,
  239,151,151, 77, 77, 77,  0,255
};

static const char boxur[]=  // end message background characters
{
    8,  0,  8,  0,  0,  0,  0,  0,
   40,  0,  0,  0, 53,  0,  0,  0, 66,  0,  0,  0, 79,  0,  0,  0,
   92,  0,  0,  0,105,  0,  0,  0,118,  0,  0,  0,131,  0,  0,  0,
    0,  8,  0,  9, 11,239, 78, 78, 77,151,151,  0,255,  0,  8,  0,
   10,126,239, 77,151, 77,151, 77,  0,255,  0,  8,  0,  9,126,239,
  151, 78,151, 76,151,  0,255,  0,  8,  0, 10,126,239,151,151, 77,
   76, 76,  0,255,  0,  8,  0,  9,126,239,151,151,151,151, 76,  0,
  255,  0,  8,  0, 10,126,239,238,238,238,238,238,  0,255,  0,  8,
    0, 10, 11,126, 11,126,126,126,126,  0,255,  0,  8,  0,159, 10,
   10, 10, 10,  9, 10,  9,  0,255
};

static const char sttminus[]=  // minus on status bar
{
    8,  0,  6,  0,  0,  0,  0,  0,
   40,  0,  0,  0, 50,  0,  0,  0, 61,  0,  0,  0, 72,  0,  0,  0,
   83,  0,  0,  0, 94,  0,  0,  0,105,  0,  0,  0,116,  0,  0,  0,
    0,  5,  0,191,191,191,191,191,  0,255,  0,  6,  0,191,180,182,
  186,191,109,  0,255,  0,  6,  0,191,177,183,186,191,109,  0,255,
    0,  6,  0,191,177,181,186,191,109,  0,255,  0,  6,  0,191,177,
  183,187,191,109,  0,255,  0,  6,  0,191,182,184,185,191,109,  0,
  255,  0,  6,  0,191,191,191,191,191,109,  0,255,  1,  5,  0,109,
  109,109,109,109,  0,255,  0,  0
};

// A new setup menu was added in BOOM, and the various menu graphic
// text strings etc. are included here.


const char m_palno[]=  // Marker to not show this color in automap
{
    7,  0,  7,  0,  0,  0,  0,  0,
   36,  0,  0,  0, 48,  0,  0,  0, 60,  0,  0,  0, 72,  0,  0,  0,
   84,  0,  0,  0, 96,  0,  0,  0,108,  0,  0,  0,  0,  7,  0,  4,
    0,  0,  0,  0,  0,  4,  0,255,  0,  7,  0,  0,  4,  0,  0,  0,
    4,  0,  0,255,  0,  7,  0,  0,  0,  4,  0,  4,  0,  0,  0,255,
    0,  7,  0,  0,  0,  0,  4,  0,  0,  0,  0,255,  0,  7,  0,  0,
    0,  4,  0,  4,  0,  0,  0,255,  0,  7,  0,  0,  4,  0,  0,  0,
    4,  0,  0,255,  0,  7,  0,  4,  0,  0,  0,  0,  0,  4,  0,255,
};

static const char stcfn096[]= // backquote character, never existed
{
    4,  0,  4,  0,  0,  0,  0,  0,
   24,  0,  0,  0, 32,  0,  0,  0, 41,  0,  0,  0, 50,  0,  0,  0,
    0,  3,  0,191,191,191,  0,255,  0,  4,  0,191,179,179,191,  0,
  255,  0,  4,  0,191,181,191,191,  0,255,  0,  3,  0,191,191,191,
    0,255,
};

// colormap for underwater, original default greenish
const unsigned char watermap[] = {
  0,126,127,103,193,5,6,7,8,123,124,126,12,122,123,124,193,193,194,194,88,90,
  92,93,95,96,98,98,100,101,102,103,3,105,106,107,14,15,15,238,238,239,239,239,
  1,2,2,2,193,193,193,193,193,193,193,86,112,112,112,112,113,114,115,115,115,
  116,117,117,118,118,119,120,121,121,122,122,123,124,124,125,193,193,194,194,
  194,194,194,194,194,194,194,194,194,195,195,195,93,94,95,96,97,98,100,101,
  102,104,104,106,106,108,109,110,112,112,113,113,113,114,115,115,117,119,120,
  121,123,124,125,127,112,112,112,113,114,115,115,116,117,118,118,119,119,121,
  121,122,115,116,117,118,120,121,122,123,115,116,117,118,119,121,121,122,112,
  112,112,114,117,120,122,78,193,193,193,194,91,95,136,34,186,187,187,188,188,
  189,189,45,45,46,47,47,47,47,2,2,193,194,194,195,196,197,198,199,200,200,200,
  200,201,202,204,205,193,193,193,193,112,112,114,116,117,118,118,120,120,120,
  74,75,193,193,193,86,112,112,113,114,75,75,76,77,122,124,125,126,205,206,207,
  241,243,244,246,0,113,112,195,198,198,199,204,96,0,126,127,103,193,5,6,7,8,
  123,124,126,12,122,123,124,193,194,194,88,90,90,93,95,95,96,98,98,100,101,
  103,103,105,105,106,107,14,15,15,238,238,239,239,239,1,2,2,2,193,193,193,193,
  193,193,86,86,112,112,112,113,114,115,115,115,115,117,117,117,118,118,120,
  120,121,121,122,122,123,124,124,125,193,194,194,194,194,194,194,194,194,194,
  194,194,195,195,195,195,94,94,95,97,97,98,101,101,103,104,104,106,106,108,
  109,110,112,112,113,113,113,114,115,115,117,119,120,121,123,124,125,127,112,
  112,113,114,115,115,115,117,117,118,118,119,119,121,122,122,115,116,117,118,
  120,121,122,123,115,116,117,118,119,121,121,122,112,112,112,114,117,120,122,
  78,193,193,193,194,91,95,136,34,186,187,188,188,188,189,189,45,45,46,47,47,
  47,47,2,2,193,194,194,195,196,197,198,199,200,200,200,200,201,202,204,205,
  193,193,193,193,112,112,114,116,118,118,120,120,120,120,75,75,193,193,193,86,
  112,112,113,114,75,75,76,77,122,124,125,126,205,206,207,241,243,244,246,0,
  113,112,195,198,198,199,204,96,0,126,127,104,193,5,6,7,8,123,124,126,12,122,
  123,124,193,194,194,90,90,92,93,95,96,98,98,100,101,102,103,3,105,106,107,14,
  15,15,238,238,239,239,239,1,1,2,2,2,193,193,193,193,193,193,86,112,112,112,
  112,113,114,115,115,115,116,117,117,118,118,119,120,121,121,122,122,123,123,
  124,124,125,194,194,194,194,194,194,194,194,194,194,194,194,195,195,195,93,
  94,95,96,97,98,100,101,102,103,104,104,106,106,108,109,110,112,113,113,113,
  114,115,115,117,119,119,120,121,123,124,125,127,112,112,113,114,115,115,116,
  117,118,118,119,119,121,121,122,122,115,117,118,119,121,121,123,124,116,117,
  118,118,119,121,122,122,112,112,112,114,117,120,122,78,193,193,193,88,91,95,
  136,34,187,187,188,188,189,189,45,45,46,47,47,47,47,2,2,2,194,194,194,195,
  196,197,198,199,200,200,200,200,201,202,204,205,193,193,193,86,112,112,114,
  117,118,118,120,120,120,74,75,75,193,193,193,86,112,112,113,114,75,76,76,77,
  123,124,125,126,205,206,207,241,243,244,246,0,114,112,195,198,198,199,204,96,
  0,126,127,104,193,5,6,7,8,123,124,126,12,123,124,125,194,194,88,90,92,93,95,
  96,98,98,100,100,101,102,3,3,106,106,107,14,15,15,238,238,239,239,1,1,1,2,2,
  2,194,193,193,193,193,194,112,112,112,112,113,114,115,115,115,116,117,117,
  118,118,118,119,121,121,121,122,122,123,123,124,125,125,194,194,194,194,194,
  194,194,194,194,194,194,195,195,195,93,94,95,95,97,98,98,100,102,102,104,104,
  106,106,108,108,110,110,112,113,113,113,114,115,115,117,119,120,121,123,123,
  124,125,127,112,113,114,115,115,116,117,118,118,119,119,119,121,121,122,122,
  116,117,118,119,121,122,123,124,116,117,118,119,121,121,122,123,112,112,114,
  117,117,120,122,78,193,194,194,88,92,95,136,34,187,188,188,189,189,189,45,45,
  46,47,47,47,47,2,2,2,194,194,195,195,196,197,198,199,200,200,200,201,202,202,
  204,206,193,194,193,112,112,113,114,118,118,120,120,120,74,75,75,75,193,193,
  193,86,112,112,113,114,75,76,77,78,123,124,125,126,206,207,207,241,243,244,
  246,0,114,112,195,198,198,199,204,96,0,126,127,104,194,5,6,7,8,123,124,126,
  12,123,124,125,194,88,90,90,93,93,95,96,98,100,100,101,102,103,3,105,106,107,
  14,15,15,15,238,238,239,239,1,1,2,2,2,2,194,194,193,193,194,194,194,112,112,
  113,114,115,115,115,116,116,117,118,118,118,119,120,121,121,121,122,122,123,
  124,124,125,125,194,194,194,194,194,194,194,194,194,194,195,195,195,93,93,95,
  95,96,97,98,100,101,102,103,104,106,106,106,108,109,110,5,113,113,113,114,
  114,115,115,117,119,120,121,123,123,124,125,127,113,113,114,115,116,116,117,
  118,118,119,119,121,121,122,122,122,116,117,118,120,121,122,123,124,116,118,
  118,119,121,121,122,123,112,112,114,117,120,122,78,78,194,194,194,90,93,96,
  136,34,187,188,188,189,189,45,45,46,46,47,47,47,47,2,2,2,194,194,195,196,196,
  197,198,199,200,200,200,201,202,204,205,206,194,194,193,112,112,114,115,118,
  120,120,120,120,74,75,75,75,194,194,193,112,112,112,113,114,76,76,77,78,123,
  124,125,126,206,207,241,241,243,244,246,0,115,112,195,198,199,199,204,117,0,
  127,127,104,194,5,6,7,8,123,124,126,12,123,124,125,194,90,90,93,93,95,96,98,
  98,100,101,102,103,3,105,106,106,14,14,15,15,238,238,239,239,239,1,1,2,2,2,2,
  194,194,194,112,112,112,88,112,113,114,114,115,115,116,117,117,117,118,118,
  119,119,121,121,121,122,122,122,123,124,124,125,126,194,194,194,194,194,194,
  194,194,195,195,195,195,93,94,94,95,96,97,98,100,100,101,103,103,104,106,106,
  108,108,109,110,5,113,113,113,114,115,115,117,117,119,120,121,123,124,125,
  125,127,113,114,115,115,116,117,118,118,119,119,119,121,121,122,122,123,117,
  118,119,120,121,122,123,124,117,118,119,119,121,121,122,123,112,112,114,117,
  120,122,78,78,194,194,194,90,95,98,136,188,188,188,189,189,45,45,45,46,47,47,
  47,47,47,2,2,2,194,194,195,196,197,197,198,200,200,200,200,201,202,204,205,
  206,194,194,112,112,113,115,115,118,120,120,120,74,75,75,75,76,194,194,193,
  112,112,112,112,114,76,77,78,78,123,125,125,126,206,207,241,243,243,244,246,
  0,115,112,195,198,199,204,204,117,0,127,127,106,194,6,6,7,8,124,126,126,12,
  123,124,125,112,90,92,93,95,96,96,98,100,100,102,102,103,3,106,106,14,14,15,
  15,238,238,238,239,239,1,1,2,2,2,2,2,194,194,112,112,112,112,112,113,113,114,
  115,115,116,116,117,117,118,118,119,119,120,121,121,121,122,122,123,123,124,
  124,125,126,194,194,194,194,194,194,194,194,195,195,195,195,93,94,95,96,97,
  97,98,100,101,102,103,104,104,106,106,108,108,109,110,5,113,113,114,114,115,
  115,117,119,120,120,121,123,124,125,127,127,114,115,115,116,117,117,118,118,
  119,119,121,121,121,122,123,123,117,118,119,121,122,122,124,124,117,118,119,
  121,121,122,123,123,112,112,114,117,120,122,78,78,194,194,112,92,96,98,101,
  188,188,189,189,189,45,45,46,46,47,47,47,47,2,2,2,2,194,194,195,196,197,198,
  198,200,200,200,201,201,202,204,205,206,194,194,112,112,114,115,115,120,120,
  120,74,74,75,75,75,76,194,194,112,112,112,112,112,114,76,77,78,78,124,125,
  126,126,206,207,241,243,244,244,246,0,115,112,195,198,199,204,204,118,0,127,
  127,106,194,6,6,7,8,124,126,12,12,124,124,125,112,112,93,96,96,96,96,100,100,
  101,102,103,3,105,106,106,14,14,15,15,238,238,239,239,1,1,2,2,2,2,2,2,194,
  194,112,112,112,112,112,112,114,115,115,115,116,117,117,118,118,118,119,120,
  121,121,121,122,122,122,123,124,124,124,125,126,194,194,194,194,194,194,194,
  195,195,195,93,93,94,95,95,96,98,98,100,101,101,103,104,104,106,106,106,108,
  108,109,5,5,113,113,114,115,115,115,117,119,120,120,121,123,124,125,127,127,
  115,115,116,117,117,118,118,119,119,121,121,121,122,122,123,123,118,119,119,
  121,122,123,124,124,118,118,119,121,121,122,123,123,112,114,114,117,120,122,
  78,78,194,194,112,93,96,100,102,188,188,189,189,45,45,45,46,47,47,47,47,47,2,
  2,2,2,194,194,194,196,197,198,198,200,200,200,201,202,202,204,205,206,194,
  194,112,112,114,115,117,120,120,120,74,75,75,75,76,76,194,194,112,112,112,
  112,112,114,77,78,78,78,124,125,126,126,206,207,241,243,244,244,246,0,115,
  112,90,198,199,204,204,118,0,127,127,106,194,6,7,8,8,124,126,12,12,124,125,
  125,112,112,113,96,96,96,96,100,101,102,103,103,3,106,106,14,14,15,15,238,
  238,238,239,1,1,1,2,2,2,2,2,2,194,112,112,112,112,112,112,112,115,115,115,
  116,117,117,118,118,118,119,120,121,121,121,122,122,122,123,123,124,124,125,
  125,126,194,194,194,194,194,195,195,195,195,93,94,94,95,96,96,97,98,98,100,
  101,102,103,104,104,106,106,108,108,109,110,5,5,113,114,114,115,115,117,119,
  119,120,121,123,123,124,125,127,127,115,115,116,117,118,118,119,119,119,121,
  121,122,122,123,123,124,118,119,121,121,122,123,124,124,118,119,119,121,121,
  122,123,123,112,114,117,118,120,122,78,1,194,112,112,95,98,101,103,189,189,
  189,45,45,45,46,46,47,47,47,47,47,2,2,2,2,194,194,195,196,197,198,200,200,
  200,200,201,202,204,204,205,207,194,194,112,112,115,115,117,120,120,74,75,75,
  75,76,76,77,194,194,112,112,112,112,114,114,78,78,78,239,124,125,126,126,207,
  207,241,243,244,244,246,0,116,114,90,198,199,204,204,118,0,127,127,106,194,6,
  7,8,8,124,126,12,12,124,125,125,112,113,96,96,96,96,100,100,118,103,119,120,
  106,106,14,14,15,15,15,238,238,239,1,1,1,1,2,2,2,2,2,2,194,112,112,112,112,
  112,113,113,115,115,116,117,117,118,118,118,119,120,120,121,121,121,122,122,
  122,123,124,124,124,125,125,126,194,194,194,194,195,195,195,195,93,93,94,95,
  96,96,97,98,100,100,101,102,103,104,104,104,106,106,108,109,109,110,5,5,113,
  114,115,115,115,117,119,120,120,121,123,123,124,125,127,127,115,116,117,118,
  118,118,119,119,121,121,121,122,122,123,123,124,118,119,121,121,122,123,124,
  124,118,119,121,121,122,123,123,123,112,114,117,118,121,122,78,1,194,112,112,
  96,98,101,103,189,189,45,45,45,46,46,47,47,47,47,47,2,2,2,2,2,194,194,195,93,
  197,198,200,200,200,201,201,202,204,205,205,207,194,112,112,113,115,116,117,
  120,120,75,75,75,122,76,76,78,194,112,112,112,112,114,114,114,78,78,78,239,
  124,125,126,126,207,241,241,243,244,244,246,0,117,114,195,198,199,204,204,
  119,0,127,7,106,194,6,7,8,8,124,126,12,12,124,125,125,113,96,96,96,96,96,100,
  118,119,119,120,120,106,106,14,14,15,15,238,238,238,239,1,1,1,2,2,2,2,2,2,2,
  194,112,112,112,113,113,114,115,115,116,117,117,118,118,118,119,119,120,121,
  121,121,122,122,122,123,123,124,124,125,125,126,126,194,194,195,195,195,195,
  195,93,94,94,95,95,96,97,98,98,100,101,102,103,103,104,104,106,106,108,108,
  109,109,110,5,5,114,115,115,115,117,119,119,120,121,121,123,124,124,125,127,
  127,116,117,118,118,118,119,119,119,121,121,121,122,122,123,124,124,119,119,
  121,122,123,123,124,125,119,121,121,121,122,123,123,110,114,114,117,118,121,
  78,78,1,194,194,113,96,100,101,3,189,189,45,45,45,46,47,47,47,47,47,47,2,2,2,
  2,2,194,195,195,94,96,198,200,200,200,201,202,202,204,205,206,207,194,194,
  112,113,116,117,117,120,120,75,122,122,122,76,78,78,194,112,112,112,114,114,
  114,114,78,78,78,239,124,125,126,126,207,241,241,243,244,246,246,0,117,114,
  96,199,199,204,204,119,0,127,7,108,194,6,7,8,8,124,126,127,12,124,125,125,96,
  96,96,96,96,117,118,119,119,120,121,121,121,121,14,15,15,15,238,238,1,1,1,1,
  1,2,2,2,2,2,2,2,194,112,112,113,113,114,115,115,116,117,117,118,118,118,119,
  119,120,121,121,121,121,122,122,122,123,124,124,124,125,125,126,126,194,195,
  195,195,195,93,93,94,95,95,96,96,97,98,98,100,101,101,102,103,104,104,106,
  106,106,108,108,109,110,5,5,5,114,115,115,117,117,119,120,120,121,121,123,
  124,124,125,127,7,117,117,118,118,119,119,119,121,121,122,122,122,123,123,
  124,124,119,121,121,122,123,124,124,125,119,121,121,121,122,123,123,110,114,
  116,118,120,121,78,78,1,194,195,114,96,100,102,105,45,45,45,45,46,46,47,47,
  47,47,47,2,2,2,2,2,2,194,195,93,95,97,200,200,200,200,201,202,204,204,205,
  206,207,194,194,113,115,116,117,120,120,120,75,122,122,122,78,78,78,194,112,
  112,113,114,114,114,117,78,78,78,239,124,125,126,126,207,241,243,243,244,246,
  246,0,117,114,96,199,199,204,204,119,0,127,7,108,194,6,7,8,8,5,126,12,8,124,
  125,125,96,96,96,117,117,118,118,119,120,120,121,121,121,121,15,15,15,238,
  238,239,1,1,1,1,2,2,2,2,2,2,2,2,195,113,113,114,114,115,115,115,116,117,118,
  118,118,119,120,120,121,121,121,121,122,122,122,123,123,124,124,124,125,125,
  126,126,195,195,195,195,93,94,94,95,96,96,97,97,98,100,100,101,102,102,103,
  104,104,106,106,106,108,108,109,109,110,5,5,6,115,115,115,117,119,119,120,
  120,121,123,123,124,125,125,127,8,118,118,118,119,119,119,121,121,121,122,
  122,123,123,124,124,124,119,121,122,122,123,124,124,125,119,121,121,122,123,
  123,124,124,115,116,118,121,121,122,123,1,194,195,115,96,101,103,105,45,45,
  45,46,46,47,47,47,47,47,47,2,2,2,2,2,2,195,195,94,96,98,201,201,201,201,202,
  202,204,204,205,206,241,194,195,114,115,117,118,120,120,122,122,122,122,122,
  78,78,78,194,112,113,115,114,114,117,117,78,78,239,1,124,125,126,127,241,241,
  243,243,244,246,246,0,118,117,96,199,204,204,108,119,0,127,7,108,195,6,7,8,8,
  5,126,12,8,125,125,126,96,116,117,117,118,118,119,119,119,121,121,121,121,
  122,15,15,238,238,238,1,1,1,1,2,2,2,2,2,2,2,2,127,195,114,114,115,115,115,
  116,116,116,118,118,118,119,120,120,121,121,121,121,122,122,122,123,123,124,
  124,125,124,125,126,126,126,195,195,93,93,94,95,95,96,96,97,98,98,100,100,
  101,101,102,103,104,104,104,106,106,106,108,109,109,110,110,5,5,6,115,115,
  117,117,119,120,120,121,121,123,123,124,125,125,127,8,118,118,119,119,119,
  121,121,121,122,122,122,123,123,124,124,124,121,121,122,123,124,124,125,125,
  121,121,121,122,123,123,124,124,116,116,118,121,122,123,124,126,195,195,115,
  117,102,3,106,45,45,46,46,47,47,47,47,47,47,2,2,2,2,2,2,127,195,93,95,97,98,
  201,201,201,201,202,202,204,205,205,207,241,195,195,115,115,117,118,120,120,
  122,122,122,122,78,78,78,78,195,195,114,115,116,117,117,117,78,78,239,1,125,
  125,126,127,241,241,243,244,244,246,246,0,118,117,96,199,204,204,108,121,0,
  127,8,109,195,6,7,8,8,125,126,127,8,125,125,126,116,117,117,118,118,118,119,
  119,121,121,121,121,122,122,123,123,124,238,1,1,1,1,1,2,2,2,2,2,2,2,127,127,
  93,115,115,115,115,116,116,117,117,118,118,119,120,121,121,121,121,122,122,
  122,122,123,123,124,124,124,125,125,125,126,126,127,93,93,94,94,95,96,96,97,
  97,98,98,100,100,101,101,102,103,104,104,106,106,106,106,108,108,109,109,110,
  5,5,6,6,115,117,117,119,119,120,121,121,123,123,124,124,125,127,127,8,118,
  119,119,119,121,121,121,122,122,122,123,123,124,124,124,125,121,122,122,123,
  124,124,125,125,121,121,122,122,123,109,124,5,116,117,120,121,122,123,124,
  126,195,93,116,117,103,105,107,15,46,46,47,47,47,47,47,47,47,2,2,2,2,2,2,127,
  93,95,96,98,100,201,201,201,201,202,204,204,205,206,207,241,195,93,115,116,
  117,118,119,122,122,122,122,78,78,78,78,78,195,195,115,116,116,117,117,117,
  78,239,1,1,125,126,126,127,241,243,243,244,244,246,246,0,119,117,96,199,204,
  204,109,121,0,7,8,109,195,7,7,8,8,126,127,127,8,125,125,126,117,117,118,118,
  119,119,119,121,121,121,122,122,122,122,123,123,124,124,1,1,1,1,2,2,2,2,2,2,
  2,2,127,127,94,95,115,116,116,117,117,117,117,118,118,120,121,121,121,121,
  122,122,122,122,122,123,124,124,124,125,125,125,125,126,126,127,94,94,95,95,
  96,97,97,98,98,98,100,100,101,102,102,103,104,104,104,106,106,106,108,108,
  109,109,110,5,5,5,6,6,117,117,119,119,120,120,121,121,123,123,124,124,125,
  127,127,8,119,119,119,121,121,121,122,122,122,123,123,124,124,124,124,125,
  121,122,123,123,124,124,125,126,121,122,122,123,123,110,124,5,116,118,121,
  121,122,123,125,126,195,95,117,118,119,106,107,15,46,47,47,47,47,47,47,47,2,
  2,2,2,2,2,2,127,94,95,97,98,101,202,202,202,202,202,204,204,205,206,207,241,
  195,94,116,117,118,119,120,122,122,122,78,78,78,78,78,78,195,94,115,116,116,
  117,117,120,239,1,1,1,125,126,126,127,241,243,243,244,244,246,246,0,120,118,
  96,199,204,204,109,121,0,7,8,109,94,7,7,8,8,126,127,127,8,125,126,126,118,
  118,118,119,119,119,121,121,121,121,122,122,122,123,123,124,124,124,125,1,1,
  2,2,2,2,2,2,2,127,127,127,127,95,115,117,117,117,118,118,118,118,118,120,121,
  121,121,121,121,122,122,122,122,123,124,124,124,124,125,125,125,125,126,126,
  127,95,95,96,96,97,98,98,98,100,100,101,101,102,103,103,104,104,104,106,106,
  106,108,108,108,109,110,110,5,5,5,6,6,117,119,119,120,120,121,121,123,123,
  123,124,125,125,127,127,8,119,119,121,121,121,122,122,122,123,123,123,124,
  124,124,125,125,122,122,123,124,124,125,125,126,121,122,122,123,109,110,124,
  5,117,118,121,122,122,123,125,126,94,95,117,118,120,106,14,15,47,47,47,47,47,
  47,47,2,2,2,2,2,2,2,127,127,95,96,98,100,102,202,202,202,202,204,204,205,205,
  206,207,241,94,95,117,118,118,120,121,122,122,78,78,78,78,78,78,239,94,115,
  115,116,117,118,120,120,1,1,1,2,125,126,126,127,241,243,243,244,244,246,246,
  0,121,118,97,204,204,204,110,122,0,7,8,110,95,7,7,8,0,6,127,7,8,125,126,126,
  118,119,119,119,119,121,121,121,122,122,122,122,123,123,124,124,124,125,125,
  125,126,126,126,2,2,2,2,127,127,127,127,127,96,97,117,118,118,118,118,118,
  119,119,120,121,121,121,122,122,122,122,123,123,124,124,124,124,125,125,125,
  125,126,126,127,127,96,97,97,97,98,98,100,100,101,101,102,102,103,104,104,
  104,106,106,106,106,108,108,108,109,109,110,5,5,5,6,6,6,119,119,120,120,120,
  121,121,123,123,124,124,125,125,127,127,8,121,121,121,121,122,122,122,123,
  123,124,124,124,124,125,125,125,122,123,123,124,124,125,126,126,122,122,123,
  123,110,124,5,5,118,120,121,122,123,124,125,126,95,97,118,119,121,14,15,238,
  47,47,47,47,47,47,2,2,2,2,2,2,2,2,127,127,96,98,100,101,103,202,202,202,202,
  204,204,205,206,207,241,243,95,96,118,118,118,121,121,122,78,78,78,78,78,78,
  1,1,95,115,116,117,118,118,120,120,1,1,1,2,125,126,127,127,243,243,244,244,
  246,246,0,0,121,120,98,204,204,204,110,122,0,7,8,110,96,7,8,8,0,6,127,7,8,
  126,126,126,119,119,119,121,121,121,121,122,122,122,123,123,123,124,124,124,
  125,125,125,126,126,126,126,126,126,126,127,127,127,127,127,127,97,98,118,
  118,118,119,119,119,119,120,121,121,122,122,122,122,122,123,123,124,124,124,
  125,125,125,125,125,126,126,126,127,127,97,98,98,98,100,100,101,101,102,102,
  103,103,104,104,104,106,106,106,106,108,108,108,109,109,110,5,5,5,5,6,6,6,
  119,119,120,120,121,121,123,123,124,124,124,125,127,127,7,8,121,121,121,122,
  122,122,123,123,124,124,124,124,110,125,125,5,122,123,124,124,125,125,126,
  126,122,123,123,109,110,5,5,126,118,120,122,122,123,124,126,126,96,98,119,
  119,121,14,15,238,47,47,47,47,47,2,2,2,2,2,2,2,2,127,127,127,97,98,101,102,
  104,204,204,204,204,204,205,205,206,207,241,243,96,97,118,119,120,121,121,78,
  78,78,78,78,78,1,1,1,96,116,116,118,118,121,121,122,1,1,126,2,126,126,127,
  127,243,243,244,244,246,246,0,0,121,121,100,204,204,108,110,123,0,8,8,5,97,7,
  8,8,0,6,127,8,8,126,126,127,119,119,121,121,121,121,122,122,123,123,123,123,
  124,124,125,125,125,125,126,126,126,126,126,126,126,127,127,127,127,127,127,
  127,98,100,119,119,119,119,119,119,121,121,121,121,122,122,122,122,123,124,
  124,124,124,125,125,125,125,125,126,126,126,127,127,127,98,100,100,100,101,
  102,102,102,103,103,104,104,104,106,106,106,106,106,108,108,108,109,109,110,
  110,5,5,5,6,6,6,7,120,120,120,121,121,123,123,123,124,124,125,125,127,127,8,
  8,121,122,122,122,123,123,123,124,124,109,124,125,125,125,5,126,123,124,124,
  124,125,125,126,126,108,123,109,110,5,5,126,6,120,120,122,123,124,125,126,
  126,97,100,119,121,121,15,238,239,47,47,47,47,2,2,2,2,2,2,2,2,2,127,127,127,
  98,101,102,103,104,204,204,204,204,205,205,206,207,207,241,243,97,98,119,119,
  120,121,122,78,78,78,78,78,1,1,1,1,97,117,117,118,120,120,121,122,126,126,
  126,2,126,126,127,127,243,243,244,244,246,246,0,0,122,120,101,204,204,109,5,
  123,0,8,8,5,98,7,8,8,0,6,7,8,8,126,126,127,121,121,121,121,122,122,122,123,
  123,123,124,124,124,125,125,125,126,126,126,126,126,126,126,126,127,127,127,
  127,127,127,127,127,100,101,119,119,119,121,121,121,121,121,122,122,122,122,
  123,123,124,124,124,124,125,125,125,125,125,126,126,126,126,127,127,127,100,
  101,101,102,102,103,103,104,104,104,104,104,106,106,106,106,108,108,108,109,
  109,109,110,110,5,5,5,6,6,6,6,7,120,120,121,121,123,123,123,124,124,124,125,
  125,127,127,8,8,122,122,106,106,123,108,108,124,109,109,110,125,125,5,126,
  126,123,124,124,125,125,126,126,127,123,109,110,110,5,5,126,6,120,121,122,
  123,124,125,126,126,98,101,121,121,122,122,238,239,47,47,2,2,2,2,2,2,2,2,2,2,
  127,127,127,127,100,102,103,104,106,204,204,204,204,205,206,206,207,241,243,
  243,98,101,119,121,121,122,122,78,78,78,123,124,125,1,126,126,98,118,118,120,
  120,120,122,122,126,126,126,126,126,127,127,127,243,244,244,244,246,246,0,0,
  122,122,102,204,204,109,5,124,0,8,8,5,101,7,8,8,0,127,7,8,8,126,127,127,121,
  121,122,122,122,122,123,123,124,124,124,124,125,125,125,126,126,126,126,126,
  126,126,126,126,127,127,127,127,127,127,127,127,102,102,103,121,121,121,121,
  121,122,122,122,122,123,123,124,124,124,124,125,125,125,125,125,125,126,126,
  126,126,127,127,127,7,102,102,103,103,103,104,104,104,104,106,106,106,106,
  106,106,108,108,108,109,109,109,110,5,5,5,5,5,6,6,6,7,7,121,121,121,123,123,
  123,124,124,124,125,125,127,127,127,8,8,106,106,106,108,108,108,109,109,109,
  110,110,125,5,126,126,126,124,124,124,125,126,126,126,127,109,110,110,5,5,5,
  6,6,121,122,123,124,125,126,126,126,101,102,121,122,122,123,238,239,47,2,2,2,
  2,2,2,2,2,2,2,127,127,127,127,127,102,103,104,106,106,205,205,205,205,205,
  206,207,207,241,243,243,101,102,121,121,122,122,123,123,123,124,124,125,125,
  126,126,126,101,118,119,119,121,122,122,122,126,126,126,126,126,127,127,7,
  243,244,244,246,246,246,0,0,122,122,104,204,204,110,5,124,0,8,8,5,102,8,8,0,
  0,7,7,8,8,127,127,127,122,122,122,123,123,123,124,124,124,124,125,125,125,
  125,126,126,126,126,126,126,126,126,127,127,127,127,127,127,127,127,127,127,
  103,104,104,121,121,122,122,122,122,122,123,123,124,124,124,124,124,125,125,
  125,125,125,126,126,126,126,126,126,127,127,127,7,103,104,104,104,104,104,
  106,106,106,106,106,106,108,108,108,108,109,109,109,110,110,5,5,5,5,6,6,6,6,
  6,7,7,121,121,123,123,123,124,124,124,125,125,125,127,127,127,8,8,106,108,
  108,108,109,109,109,110,110,110,5,5,5,126,126,126,124,124,125,125,126,126,
  127,127,110,110,5,5,5,6,6,6,121,122,123,124,125,126,126,127,102,104,122,122,
  123,124,1,1,2,2,2,2,2,2,2,2,2,2,127,127,127,127,127,127,103,104,106,106,108,
  205,205,205,205,206,207,207,241,241,243,244,102,103,121,122,122,123,123,124,
  124,125,125,125,126,126,126,126,102,103,119,121,122,122,122,122,126,126,126,
  126,127,127,127,8,244,244,244,246,246,246,0,0,123,122,104,204,108,110,6,125,
  0,8,8,6,104,8,8,0,0,7,8,8,0,127,127,127,122,123,123,123,123,124,124,124,125,
  125,125,125,126,126,126,126,126,126,126,126,126,127,127,127,127,127,127,127,
  127,127,8,8,104,104,104,122,122,122,122,123,123,123,124,124,124,124,125,125,
  125,125,125,125,126,126,126,126,126,126,126,127,127,127,7,8,104,104,104,106,
  106,106,106,106,106,108,108,108,108,109,109,109,109,110,110,5,5,5,5,5,6,6,6,
  6,6,7,7,7,123,123,123,123,124,124,124,125,125,125,127,127,127,8,8,8,108,108,
  109,109,109,110,110,110,5,5,5,126,126,126,6,127,124,125,125,126,126,126,127,
  127,110,5,5,5,6,6,6,127,122,123,124,124,125,126,126,127,104,104,122,123,124,
  124,1,1,2,2,2,2,2,2,2,2,2,127,127,127,127,127,127,8,104,106,106,108,108,206,
  206,206,206,207,207,241,241,243,243,244,104,104,122,122,123,124,124,125,125,
  125,126,126,126,126,126,126,104,104,121,121,122,122,123,123,126,126,126,127,
  127,127,7,8,244,244,244,246,246,246,0,0,124,123,106,204,109,5,6,110,0,8,8,6,
  104,8,8,0,0,7,8,8,0,127,127,7,123,123,124,124,124,124,125,125,125,125,126,
  126,126,126,126,126,126,126,126,127,127,127,127,127,127,127,127,127,127,8,8,
  8,106,106,106,106,123,123,123,123,124,124,124,124,125,125,125,125,125,125,
  125,126,126,126,126,126,126,127,127,127,127,7,7,8,106,106,106,106,106,106,
  108,108,108,108,108,109,109,109,109,110,110,110,5,5,5,5,5,6,6,6,6,6,7,7,7,7,
  123,123,124,124,124,124,125,125,125,125,127,127,127,8,8,8,109,109,109,110,
  110,110,5,5,5,5,126,126,126,6,127,127,125,125,126,126,126,127,127,127,5,5,5,
  6,6,6,127,7,123,124,124,125,126,126,126,127,104,106,123,124,124,125,126,2,2,
  2,2,2,2,2,2,2,127,127,127,127,127,127,8,8,106,106,108,108,109,207,207,207,
  207,207,241,241,243,243,244,244,104,106,106,123,124,124,125,125,126,126,126,
  126,126,126,126,126,104,106,121,122,123,123,124,124,126,126,127,127,127,127,
  7,8,244,244,246,246,246,246,0,0,124,123,106,109,110,5,6,110,0,8,0,6,106,8,8,
  0,0,7,8,8,0,127,7,7,108,124,109,109,125,125,125,126,126,126,126,126,126,126,
  126,126,126,127,127,127,127,127,127,127,127,127,127,127,8,8,8,8,106,108,108,
  108,108,124,124,124,124,125,125,125,125,125,125,126,126,126,126,126,126,126,
  126,126,127,127,127,127,7,7,8,8,106,106,108,108,108,108,108,109,109,109,109,
  109,110,110,110,5,5,5,5,5,5,6,6,6,6,6,6,7,7,7,7,8,124,124,124,124,125,125,
  125,125,127,127,127,127,7,8,8,0,110,110,110,110,5,5,5,5,126,126,126,6,6,127,
  127,127,5,126,126,126,127,127,127,7,5,6,6,6,6,7,7,7,123,124,124,125,126,126,
  127,127,106,108,108,124,125,125,126,2,2,2,2,2,2,2,127,127,127,127,127,127,
  127,8,8,8,106,108,108,109,110,207,207,207,207,241,241,243,243,243,244,244,
  106,106,108,124,124,125,125,126,126,126,126,126,126,126,126,126,106,106,122,
  123,124,124,124,124,126,127,127,127,127,7,8,8,244,246,246,246,246,0,0,0,125,
  124,108,109,5,5,6,5,0,8,0,7,108,8,8,0,0,8,8,8,0,7,7,8,109,110,110,110,110,
  125,126,126,126,126,126,126,126,126,127,127,127,127,127,127,127,127,127,127,
  127,8,8,8,8,8,8,8,108,108,109,109,109,109,125,125,125,125,125,125,125,126,
  126,126,126,126,126,126,126,127,127,127,127,127,127,7,7,8,8,8,108,108,109,
  109,109,109,109,110,110,110,110,5,5,5,5,5,5,5,6,6,6,6,6,6,6,7,7,7,7,7,8,8,
  124,124,125,125,125,125,125,127,127,127,127,127,8,8,8,0,110,5,5,5,5,5,126,
  126,6,6,6,127,127,127,7,7,126,126,126,127,127,127,7,7,6,6,6,6,7,7,7,7,124,
  125,125,126,126,127,127,127,108,108,109,125,126,126,126,2,2,2,2,127,127,127,
  127,127,127,127,127,127,8,8,8,8,108,109,109,110,5,241,241,241,241,241,243,
  243,243,244,244,246,108,108,109,124,125,125,126,126,126,126,126,126,126,126,
  127,127,108,108,123,123,124,124,124,124,127,127,127,127,7,7,8,8,246,246,246,
  246,246,0,0,0,126,124,109,110,5,6,7,126,0,8,0,7,109,8,0,0,0,8,8,0,0,7,8,8,
  110,5,5,5,5,126,126,126,126,126,126,127,127,127,127,127,127,127,127,127,127,
  127,127,8,8,8,8,8,8,8,8,0,109,110,110,110,110,110,125,125,125,125,126,126,
  126,126,126,126,126,126,127,127,127,127,127,127,127,127,7,7,8,8,8,8,109,110,
  110,110,110,110,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,7,7,7,7,7,7,7,8,8,8,125,125,
  125,125,125,127,127,127,127,127,7,8,8,8,0,0,5,5,5,6,6,6,6,6,6,127,127,127,7,
  7,7,7,6,6,127,127,7,7,8,8,6,6,6,7,7,7,7,8,124,125,126,126,127,127,127,127,
  109,110,110,5,126,126,126,127,127,127,127,127,127,127,127,127,127,127,8,8,8,
  8,8,0,109,110,110,5,5,243,243,243,243,243,243,244,244,244,244,246,109,109,
  110,125,125,126,126,126,126,126,126,127,127,127,127,127,109,109,110,124,124,
  124,124,124,127,127,127,127,7,8,8,8,246,246,246,246,0,0,0,0,126,125,110,5,6,
  6,7,6,0,0,0,7,110,0,0,0,0,8,8,0,0,8,8,8,5,5,126,126,126,126,127,127,127,127,
  127,127,127,127,127,127,127,127,7,8,8,8,8,8,8,8,8,8,8,0,0,0,5,5,5,5,5,5,126,
  126,126,126,126,126,126,127,127,127,127,127,127,127,127,127,127,7,7,7,8,8,8,
  8,8,8,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,7,7,8,8,8,8,8,8,125,
  125,127,127,127,127,127,127,7,8,8,8,8,8,0,0,6,6,6,6,6,6,127,7,7,7,7,7,7,7,8,
  8,127,127,7,7,7,8,8,8,7,7,7,7,7,8,8,8,126,126,126,127,127,127,127,8,110,5,5,
  126,126,127,127,127,127,127,127,127,127,127,127,127,8,8,8,8,8,8,0,0,5,5,5,6,
  6,243,243,243,243,244,244,244,244,246,246,246,110,5,5,126,126,126,126,127,
  127,127,127,127,127,127,127,127,110,5,5,126,126,126,126,126,127,127,127,8,8,
  8,8,0,246,246,246,246,0,0,0,0,126,126,5,6,6,7,7,127,0,0,0,8,5,0,0,0,0,8,0,0,
  0,8,8,8,6,6,6,127,127,127,127,127,127,127,7,7,7,7,7,7,8,8,8,8,8,8,8,8,8,8,8,
  8,0,0,0,0,6,6,6,6,6,6,6,6,127,127,127,127,127,127,127,127,127,127,7,7,7,7,8,
  8,8,8,8,8,8,8,8,0,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,7,7,7,7,7,8,8,8,8,8,8,
  8,8,0,127,127,127,127,127,7,7,8,8,8,8,8,8,0,0,0,6,6,7,7,7,7,7,7,7,7,7,8,8,8,
  8,8,7,7,7,8,8,8,8,8,7,7,7,8,8,8,8,8,126,127,127,127,127,8,8,8,5,6,6,6,127,
  127,127,127,127,127,127,8,8,8,8,8,8,8,8,8,0,0,0,0,6,6,6,6,6,244,244,244,244,
  244,244,244,246,246,246,246,5,6,6,6,127,127,127,127,127,127,127,127,127,127,
  127,8,5,6,6,126,126,126,126,12,8,8,8,8,8,8,0,0,246,246,246,0,0,0,0,0,127,127,
  6,6,7,7,8,7,0,0,0,8,6,0,0,0,0,0,0,0,0,8,0,0,7,7,7,7,7,7,7,7,7,8,8,8,8,8,8,8,
  8,8,8,8,8,8,0,0,0,0,0,0,0,0,0,0,6,7,7,7,7,7,7,7,7,7,7,7,7,7,8,8,8,8,8,8,8,8,
  8,8,8,8,8,8,0,0,0,0,6,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,8,8,8,8,8,8,8,8,8,8,8,8,
  0,0,0,0,7,7,8,8,8,8,8,8,8,8,8,0,0,0,0,0,7,7,7,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,
  8,8,8,8,8,0,8,8,8,8,8,8,8,0,127,7,7,8,8,8,8,0,6,7,7,7,7,7,8,8,8,8,8,8,8,8,8,
  0,0,0,0,0,0,0,0,0,7,7,7,7,7,246,246,246,246,246,246,246,246,246,246,0,6,6,7,
  7,7,7,7,8,8,8,8,8,8,8,8,8,6,6,7,127,127,127,12,12,8,8,8,0,8,0,0,0,0,0,0,0,0,
  0,0,0,7,127,7,7,8,8,8,8,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,8,8,8,8,8,8,8,8,8,8,
  8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,
  8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,0,0,0,
  0,0,0,0,0,0,0,0,0,0,8,8,8,8,8,0,0,0,0,0,0,0,0,0,0,0,8,8,8,8,8,8,8,8,0,0,0,0,
  0,0,0,0,8,8,0,0,0,0,0,0,8,0,0,0,0,0,0,0,8,8,8,8,0,0,0,0,8,8,8,8,8,8,8,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,8,8,246,246,246,246,246,246,246,0,0,0,0,8,
  8,8,8,8,8,8,8,8,0,0,0,0,0,0,0,8,8,8,8,8,8,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,8,8,8,8,8,0,0,8,193,193,193,194,0,193,193,193,193,194,194,193,193,194,194,
  194,108,106,104,103,102,100,98,97,95,94,93,195,195,195,194,194,194,194,194,
  194,194,194,194,194,194,194,194,194,194,193,193,193,7,6,6,5,110,109,108,108,
  106,104,104,102,101,98,97,97,95,94,93,93,195,195,194,194,194,194,194,194,194,
  194,194,194,7,6,5,5,109,108,108,106,104,104,102,101,100,98,97,96,95,94,93,
  195,195,195,194,194,194,194,194,194,194,194,194,194,106,104,102,100,97,95,93,
  195,195,194,194,194,194,194,193,193,102,101,98,97,96,95,94,93,195,195,195,
  194,194,194,194,194,95,93,195,195,194,194,194,194,93,195,195,194,194,194,194,
  194,7,108,104,98,94,195,194,194,0,6,109,104,100,96,93,194,194,194,194,194,
  194,194,194,194,194,194,194,194,194,193,193,193,7,109,104,100,95,195,194,194,
  194,194,194,193,193,193,193,193,0,7,5,109,106,104,101,98,96,95,94,93,195,195,
  194,194,0,0,8,7,7,6,5,5,194,194,194,194,194,194,194,194,193,193,193,193,193,
  193,193,193,103,110,104,195,194,194,194,94,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,
};

// There are some lumps that need to be included in order to use old
// versions of the DOOM IWADs, notably versions 1.1 and 1.2.  These
// are included here.

static const char stbar[] = {  // default status bar
  64,1,32,0,0,0,0,0,8,5,0,0,45,5,0,0,82,5,0,0,119,5,0,0,156,5,0,0,193,5,0,0,
  230,5,0,0,11,6,0,0,48,6,0,0,85,6,0,0,122,6,0,0,159,6,0,0,196,6,0,0,233,6,0,0,
  14,7,0,0,51,7,0,0,88,7,0,0,125,7,0,0,162,7,0,0,199,7,0,0,236,7,0,0,17,8,0,0,
  54,8,0,0,91,8,0,0,128,8,0,0,165,8,0,0,202,8,0,0,239,8,0,0,20,9,0,0,57,9,0,0,
  94,9,0,0,131,9,0,0,168,9,0,0,205,9,0,0,242,9,0,0,23,10,0,0,60,10,0,0,97,10,0,
  0,134,10,0,0,171,10,0,0,208,10,0,0,245,10,0,0,26,11,0,0,63,11,0,0,100,11,0,0,
  137,11,0,0,174,11,0,0,211,11,0,0,248,11,0,0,29,12,0,0,66,12,0,0,103,12,0,0,
  140,12,0,0,177,12,0,0,214,12,0,0,251,12,0,0,32,13,0,0,69,13,0,0,106,13,0,0,
  143,13,0,0,180,13,0,0,217,13,0,0,254,13,0,0,35,14,0,0,72,14,0,0,109,14,0,0,
  146,14,0,0,183,14,0,0,220,14,0,0,1,15,0,0,38,15,0,0,75,15,0,0,112,15,0,0,149,
  15,0,0,186,15,0,0,223,15,0,0,4,16,0,0,41,16,0,0,78,16,0,0,115,16,0,0,152,16,
  0,0,189,16,0,0,226,16,0,0,7,17,0,0,44,17,0,0,81,17,0,0,118,17,0,0,155,17,0,0,
  192,17,0,0,229,17,0,0,10,18,0,0,47,18,0,0,84,18,0,0,121,18,0,0,158,18,0,0,
  195,18,0,0,232,18,0,0,13,19,0,0,50,19,0,0,87,19,0,0,124,19,0,0,161,19,0,0,
  198,19,0,0,235,19,0,0,16,20,0,0,53,20,0,0,90,20,0,0,127,20,0,0,164,20,0,0,
  201,20,0,0,238,20,0,0,19,21,0,0,56,21,0,0,93,21,0,0,130,21,0,0,167,21,0,0,
  204,21,0,0,241,21,0,0,22,22,0,0,59,22,0,0,96,22,0,0,133,22,0,0,170,22,0,0,
  207,22,0,0,244,22,0,0,25,23,0,0,62,23,0,0,99,23,0,0,136,23,0,0,173,23,0,0,
  210,23,0,0,247,23,0,0,28,24,0,0,65,24,0,0,102,24,0,0,139,24,0,0,176,24,0,0,
  213,24,0,0,250,24,0,0,31,25,0,0,68,25,0,0,105,25,0,0,142,25,0,0,179,25,0,0,
  216,25,0,0,253,25,0,0,34,26,0,0,71,26,0,0,108,26,0,0,145,26,0,0,182,26,0,0,
  219,26,0,0,0,27,0,0,37,27,0,0,74,27,0,0,111,27,0,0,148,27,0,0,185,27,0,0,222,
  27,0,0,3,28,0,0,40,28,0,0,77,28,0,0,114,28,0,0,151,28,0,0,188,28,0,0,225,28,
  0,0,6,29,0,0,43,29,0,0,80,29,0,0,117,29,0,0,154,29,0,0,191,29,0,0,228,29,0,0,
  9,30,0,0,46,30,0,0,83,30,0,0,120,30,0,0,157,30,0,0,194,30,0,0,231,30,0,0,12,
  31,0,0,49,31,0,0,86,31,0,0,123,31,0,0,160,31,0,0,197,31,0,0,234,31,0,0,15,32,
  0,0,52,32,0,0,89,32,0,0,126,32,0,0,163,32,0,0,200,32,0,0,237,32,0,0,18,33,0,
  0,55,33,0,0,92,33,0,0,129,33,0,0,166,33,0,0,203,33,0,0,240,33,0,0,21,34,0,0,
  58,34,0,0,95,34,0,0,132,34,0,0,169,34,0,0,206,34,0,0,243,34,0,0,24,35,0,0,61,
  35,0,0,98,35,0,0,135,35,0,0,172,35,0,0,209,35,0,0,246,35,0,0,27,36,0,0,64,36,
  0,0,101,36,0,0,138,36,0,0,175,36,0,0,212,36,0,0,249,36,0,0,30,37,0,0,67,37,0,
  0,104,37,0,0,141,37,0,0,178,37,0,0,215,37,0,0,252,37,0,0,33,38,0,0,70,38,0,0,
  107,38,0,0,144,38,0,0,181,38,0,0,218,38,0,0,255,38,0,0,36,39,0,0,73,39,0,0,
  110,39,0,0,147,39,0,0,184,39,0,0,221,39,0,0,2,40,0,0,39,40,0,0,76,40,0,0,113,
  40,0,0,150,40,0,0,187,40,0,0,224,40,0,0,5,41,0,0,42,41,0,0,79,41,0,0,116,41,
  0,0,153,41,0,0,190,41,0,0,227,41,0,0,8,42,0,0,45,42,0,0,82,42,0,0,119,42,0,0,
  156,42,0,0,193,42,0,0,230,42,0,0,11,43,0,0,48,43,0,0,85,43,0,0,122,43,0,0,
  159,43,0,0,196,43,0,0,233,43,0,0,14,44,0,0,51,44,0,0,88,44,0,0,125,44,0,0,
  162,44,0,0,199,44,0,0,236,44,0,0,17,45,0,0,54,45,0,0,91,45,0,0,128,45,0,0,
  165,45,0,0,202,45,0,0,239,45,0,0,20,46,0,0,57,46,0,0,94,46,0,0,131,46,0,0,
  168,46,0,0,205,46,0,0,242,46,0,0,23,47,0,0,60,47,0,0,97,47,0,0,134,47,0,0,
  171,47,0,0,208,47,0,0,245,47,0,0,26,48,0,0,63,48,0,0,100,48,0,0,137,48,0,0,
  174,48,0,0,211,48,0,0,248,48,0,0,29,49,0,0,66,49,0,0,103,49,0,0,140,49,0,0,
  177,49,0,0,214,49,0,0,251,49,0,0,32,50,0,0,69,50,0,0,106,50,0,0,143,50,0,0,
  180,50,0,0,217,50,0,0,254,50,0,0,35,51,0,0,0,32,93,93,96,96,97,97,96,96,96,
  97,96,96,97,98,97,97,96,96,96,96,95,95,97,96,97,97,97,97,98,98,97,97,101,101,
  255,0,32,96,96,98,98,100,98,98,100,104,100,99,100,100,101,103,101,104,101,99,
  101,103,96,98,100,103,100,102,101,102,102,101,101,108,108,255,0,32,97,97,103,
  101,101,101,100,103,101,100,100,101,103,101,103,103,101,103,103,103,101,101,
  101,101,101,100,100,103,103,101,101,101,107,107,255,0,32,99,99,103,101,98,98,
  101,103,103,101,101,103,103,103,103,103,103,103,103,103,103,103,103,103,103,
  101,103,103,101,103,103,103,108,108,255,0,32,97,97,103,101,103,103,101,101,
  103,104,103,103,103,103,103,103,103,101,103,103,101,101,103,103,103,103,103,
  103,104,103,103,101,109,109,255,0,32,98,98,103,103,103,104,104,103,101,101,
  100,103,103,103,103,103,104,103,103,103,103,103,103,103,101,103,103,103,101,
  103,103,103,108,108,255,0,32,98,98,103,103,103,103,103,104,104,103,103,104,
  104,103,103,103,104,103,103,101,103,101,103,103,103,103,101,103,103,103,103,
  104,109,109,255,0,32,99,99,105,104,104,103,103,103,103,103,103,103,104,102,
  103,102,101,102,102,103,101,101,101,102,104,103,104,104,101,102,104,102,109,
  109,255,0,32,100,100,104,105,105,105,104,104,106,106,103,105,104,106,105,106,
  106,104,104,104,103,103,102,104,106,104,92,90,88,104,104,104,111,111,255,0,
  32,100,100,106,105,107,105,106,104,104,105,102,104,104,105,107,105,105,106,
  105,105,106,104,106,106,104,94,92,90,88,5,104,104,109,109,255,0,32,100,100,
  105,104,104,105,104,104,104,105,106,105,104,105,105,105,104,104,103,104,101,
  104,102,102,96,94,92,111,111,5,108,107,109,109,255,0,32,100,100,104,105,107,
  104,104,104,104,104,104,104,104,105,105,101,104,105,104,102,101,101,102,102,
  96,111,92,5,104,104,105,105,109,109,255,0,32,101,101,105,105,102,105,105,107,
  104,105,104,106,106,107,105,106,106,104,104,103,105,105,106,106,96,94,92,90,
  88,105,104,104,111,111,255,0,32,100,100,105,106,105,105,105,105,108,104,106,
  105,105,105,105,108,104,106,106,104,102,104,104,104,104,94,92,90,88,6,106,
  105,111,111,255,0,32,99,99,105,105,107,106,106,102,105,101,105,106,105,105,
  106,105,105,105,105,105,105,104,104,104,104,111,111,111,111,5,104,108,109,
  109,255,0,32,99,99,104,103,105,105,106,106,103,104,104,104,104,105,105,107,
  106,106,102,102,102,101,104,104,103,94,92,90,88,105,107,107,109,109,255,0,32,
  97,97,104,103,101,104,104,104,103,105,104,103,104,104,103,105,105,106,106,
  106,106,101,101,104,96,94,92,90,88,5,105,105,5,5,255,0,32,99,99,101,103,103,
  101,103,102,104,104,101,102,101,104,103,101,104,104,104,104,104,108,105,102,
  101,94,92,111,111,111,103,104,111,111,255,0,32,100,100,106,104,104,104,103,
  105,104,101,101,104,104,101,103,103,101,103,102,102,102,104,104,105,104,103,
  92,90,108,109,110,110,109,109,255,0,32,100,100,104,104,102,105,104,104,105,
  105,104,105,105,106,104,104,104,103,105,105,105,102,104,105,107,94,92,5,6,
  108,108,107,109,109,255,0,32,100,100,105,105,105,105,106,106,104,104,102,105,
  105,104,104,102,105,104,104,104,104,103,108,108,96,94,92,90,88,104,102,105,
  109,109,255,0,32,97,97,101,104,102,104,104,104,105,105,106,105,105,105,105,
  105,105,106,106,106,106,104,105,108,108,94,92,90,88,111,105,105,109,109,255,
  0,32,101,101,107,102,104,102,104,103,104,104,104,101,101,101,104,102,104,104,
  104,104,104,107,106,108,105,108,6,5,5,5,107,105,109,109,255,0,32,100,100,106,
  105,105,105,105,106,106,106,104,105,102,102,102,104,102,104,103,103,103,103,
  104,101,104,94,92,90,88,107,107,105,5,5,255,0,32,95,95,99,98,102,101,103,101,
  102,98,96,98,101,98,98,100,99,98,101,97,97,99,98,102,96,94,92,90,88,111,100,
  104,107,107,255,0,32,96,96,99,99,103,100,103,101,103,96,98,101,98,98,100,99,
  103,101,100,97,99,99,99,103,100,94,92,111,5,5,98,102,104,104,255,0,32,97,97,
  100,100,100,98,101,104,110,101,98,100,99,98,99,98,100,98,100,101,101,100,100,
  100,98,101,92,90,110,102,98,101,108,108,255,0,32,97,97,104,100,100,101,103,
  101,104,101,106,102,100,99,98,100,101,98,100,101,101,104,100,100,101,94,92,
  111,111,101,103,97,108,108,255,0,32,98,98,105,105,104,104,101,103,101,104,
  102,100,99,99,100,99,101,101,104,102,103,105,105,104,96,94,92,90,88,101,99,
  103,109,109,255,0,32,98,98,103,103,103,104,104,103,103,103,100,103,103,103,
  103,103,103,103,103,103,103,103,103,103,103,94,92,90,88,111,103,103,107,107,
  255,0,32,98,98,103,103,103,103,103,103,104,103,103,103,103,103,101,103,103,
  103,103,100,103,101,103,103,103,103,111,111,111,111,103,104,108,108,255,0,32,
  98,98,103,103,103,103,103,103,103,103,103,103,103,103,103,101,100,101,101,
  103,100,100,100,103,104,94,92,90,101,101,103,101,108,108,255,0,32,99,99,103,
  103,103,103,104,104,104,104,103,103,103,104,103,104,104,103,103,103,103,103,
  103,103,96,94,92,90,88,103,103,103,109,109,255,0,32,98,98,104,103,105,103,
  104,103,103,103,101,103,103,103,105,103,103,104,103,103,104,103,104,104,95,
  111,111,5,88,111,103,103,109,109,255,0,32,99,99,102,103,103,104,104,101,102,
  102,102,101,103,105,104,104,104,104,105,104,107,104,105,106,96,6,105,105,88,
  6,108,105,109,109,255,0,32,98,98,101,102,103,104,103,101,102,103,103,104,104,
  103,104,105,104,104,104,103,104,105,104,101,96,111,104,105,88,5,105,105,107,
  107,255,0,32,96,96,102,102,103,103,103,102,103,103,101,103,104,103,104,102,
  103,103,104,103,104,102,103,104,96,94,92,90,88,111,103,105,105,105,255,0,32,
  96,96,100,102,101,99,101,100,101,101,101,100,98,99,100,101,100,100,98,99,100,
  101,100,101,101,94,92,90,111,111,102,101,106,106,255,0,32,97,97,101,98,98,
  100,101,101,101,101,100,98,99,98,98,100,98,99,100,101,101,99,100,100,101,101,
  111,109,109,100,100,99,107,107,255,0,32,96,96,101,99,101,101,101,99,98,98,
  100,98,100,100,99,99,99,98,98,100,98,98,100,104,102,101,101,100,101,100,100,
  100,107,107,255,0,32,95,95,99,100,101,101,99,100,100,101,100,100,101,103,101,
  101,100,100,99,99,98,97,101,100,101,101,101,101,102,102,101,101,107,107,255,
  0,32,96,96,98,98,100,98,98,100,104,100,99,100,100,101,103,101,104,101,99,101,
  103,96,98,100,103,100,102,101,102,102,101,101,108,108,255,0,32,97,97,103,101,
  101,101,100,103,101,100,100,101,103,101,103,103,101,103,103,103,101,101,101,
  101,101,100,100,103,103,101,101,101,107,107,255,0,32,99,99,103,101,98,98,101,
  103,103,101,101,103,103,103,103,103,103,103,103,103,103,103,103,103,103,101,
  103,103,101,103,103,103,108,108,255,0,32,97,97,103,101,103,103,101,101,103,
  104,103,103,103,103,103,103,103,101,103,103,101,101,103,103,103,103,103,103,
  104,103,103,101,109,109,255,0,32,98,98,103,103,103,104,104,103,101,101,100,
  103,103,103,103,103,104,103,103,103,103,103,103,103,101,103,103,103,101,103,
  103,103,108,108,255,0,32,107,107,111,111,111,111,111,5,5,111,111,5,5,111,111,
  111,5,111,111,111,111,111,111,111,111,111,111,111,111,111,111,5,109,109,255,
  0,32,102,102,105,104,104,103,103,103,103,103,103,103,104,102,103,102,101,102,
  102,103,101,101,101,102,104,103,104,104,101,102,104,102,109,109,255,0,32,94,
  94,96,96,96,96,96,96,96,96,95,96,96,96,96,96,96,96,96,96,95,95,95,96,96,96,
  95,96,96,96,96,96,109,109,255,0,32,100,100,106,105,107,105,106,104,104,105,
  102,104,104,105,107,105,105,106,105,105,106,104,106,106,104,105,106,108,108,
  106,104,104,109,109,255,0,32,100,100,104,105,105,104,104,105,105,105,105,105,
  104,105,105,105,104,105,105,103,103,103,103,103,103,103,105,107,104,105,105,
  105,109,109,255,0,32,100,100,105,105,104,105,104,105,104,104,104,105,105,105,
  104,105,105,104,104,103,105,104,104,104,104,103,104,104,103,105,104,105,108,
  108,255,0,32,99,99,103,105,104,104,103,103,104,103,104,104,104,104,103,104,
  104,104,103,103,103,103,103,103,103,103,104,104,103,105,105,105,109,109,255,
  0,32,98,98,103,101,107,105,105,103,103,103,104,104,104,103,104,104,103,103,
  103,103,103,104,104,103,103,103,103,103,103,103,103,103,109,109,255,0,32,98,
  98,103,103,103,103,103,104,103,104,103,103,103,103,104,104,104,104,103,103,
  103,103,103,103,103,103,103,103,104,104,104,104,109,109,255,0,32,98,98,103,
  104,103,103,100,103,103,103,103,103,103,103,103,103,103,103,103,103,101,101,
  103,103,96,94,92,90,88,101,103,104,108,108,255,0,32,99,99,103,103,103,104,
  103,101,101,101,103,103,103,103,103,103,103,100,101,101,100,103,103,103,96,
  94,92,90,88,111,103,104,107,107,255,0,32,98,98,103,103,104,103,105,104,102,
  102,102,102,102,101,100,102,105,104,102,101,101,101,105,102,103,111,92,111,
  111,111,101,102,107,107,255,0,32,99,99,103,102,102,101,101,101,99,101,101,
  101,102,101,102,100,101,101,102,100,98,101,101,102,102,101,92,111,103,102,
  102,101,105,105,255,0,32,100,100,102,102,102,103,101,102,102,103,103,102,101,
  102,101,101,102,102,100,100,100,102,101,102,99,101,92,111,101,102,105,101,
  108,108,255,0,32,98,98,103,103,103,103,105,105,103,103,104,102,102,102,102,
  102,101,102,101,101,101,101,101,101,96,94,92,90,88,102,103,99,108,108,255,0,
  32,98,98,103,103,103,103,104,105,105,103,105,104,106,106,106,106,105,102,104,
  105,101,101,104,105,95,94,92,90,88,5,102,102,108,108,255,0,32,99,99,103,101,
  105,105,104,104,104,104,104,104,104,102,103,102,102,101,101,101,104,101,102,
  102,102,111,111,111,111,111,103,102,109,109,255,0,32,99,99,105,104,104,104,
  101,104,102,103,103,103,104,102,103,102,101,102,102,103,101,101,101,102,104,
  94,92,90,101,102,104,102,109,109,255,0,32,100,100,104,105,105,105,104,104,
  106,106,103,105,104,106,105,106,106,104,104,104,103,103,102,104,96,94,92,90,
  88,104,104,104,111,111,255,0,32,100,100,106,105,107,105,106,104,104,105,102,
  104,104,105,107,105,105,106,105,105,106,104,106,106,95,5,92,6,88,5,104,104,
  109,109,255,0,32,97,97,101,103,102,103,102,102,102,103,102,102,103,104,103,
  104,102,102,103,103,102,104,108,107,96,6,92,5,88,5,104,107,109,109,255,0,32,
  98,98,103,102,103,103,102,102,103,102,103,103,104,104,103,103,103,104,104,
  104,104,105,105,105,96,5,92,5,88,111,104,105,5,5,255,0,32,99,99,102,102,102,
  102,101,103,102,101,103,103,103,104,103,104,103,105,105,105,103,101,103,101,
  96,6,92,6,88,5,105,105,111,111,255,0,32,100,100,104,104,104,103,104,104,105,
  105,102,104,104,107,105,105,109,106,105,105,105,108,108,107,109,6,108,6,109,
  6,108,110,111,111,255,0,32,100,100,104,105,108,104,103,104,104,104,104,105,
  106,105,106,108,108,105,105,107,108,109,108,106,105,106,92,90,88,109,108,108,
  111,111,255,0,32,97,97,99,104,104,105,102,104,104,105,105,105,104,102,104,
  103,101,106,106,107,107,108,108,108,109,94,92,90,88,6,108,108,111,111,255,0,
  32,97,97,104,104,103,104,101,102,101,104,105,104,104,103,104,104,104,105,105,
  105,104,107,109,108,96,94,92,6,6,6,107,107,5,5,255,0,32,97,97,104,104,102,
  104,104,104,104,104,104,104,101,101,105,104,105,105,105,105,107,109,109,109,
  95,6,92,5,105,105,107,108,111,111,255,0,32,101,101,104,104,105,105,104,104,
  103,105,105,105,104,104,104,104,105,106,107,108,109,108,107,109,96,94,92,90,
  88,108,110,109,111,111,255,0,32,100,100,107,104,103,103,109,108,105,104,105,
  105,105,105,106,105,105,108,108,108,108,105,108,106,106,94,92,90,88,6,109,
  107,5,5,255,0,32,100,100,105,105,105,105,108,104,105,105,105,105,105,106,105,
  106,106,105,108,106,106,106,108,109,107,109,6,6,6,6,107,108,111,111,255,0,32,
  100,100,104,105,105,105,104,104,108,106,105,105,105,105,106,107,108,108,107,
  107,106,108,106,108,95,94,92,90,88,109,109,109,111,111,255,0,32,98,98,101,
  104,105,105,98,105,107,105,106,108,106,105,106,107,107,106,106,106,106,105,
  107,107,96,94,92,90,88,6,106,108,110,110,255,0,32,100,100,105,106,108,103,
  101,108,105,105,106,106,106,106,105,107,106,107,109,109,109,108,109,108,107,
  6,6,6,88,6,109,108,109,109,255,0,32,99,99,104,104,102,101,104,106,104,104,
  104,104,104,104,102,106,104,106,106,104,104,106,106,104,104,106,109,109,88,
  111,106,106,107,107,255,0,32,101,101,104,104,104,102,104,104,104,106,106,104,
  106,104,104,104,104,104,106,106,106,104,106,104,95,106,106,106,106,111,102,
  104,108,108,255,0,32,97,97,104,103,101,101,100,100,101,101,101,106,104,101,
  104,103,103,103,101,104,104,104,101,104,96,111,103,104,103,103,101,101,107,
  107,255,0,32,99,99,106,104,104,103,103,106,103,106,103,103,104,104,103,103,
  101,101,101,101,100,104,103,103,96,94,92,90,88,103,103,103,107,107,255,0,32,
  96,96,100,100,101,103,101,100,101,100,100,100,104,100,100,100,103,103,101,
  100,103,100,101,103,96,94,92,90,88,111,101,101,109,109,255,0,32,98,98,104,
  101,103,100,101,100,103,101,101,103,101,104,101,103,104,100,103,104,103,106,
  106,101,95,111,111,111,111,111,103,101,109,109,255,0,32,98,98,101,103,104,
  103,103,103,103,104,104,104,106,103,103,103,103,103,104,106,106,106,106,106,
  96,5,106,104,106,104,104,104,110,110,255,0,32,100,100,110,108,106,106,106,
  106,107,107,105,105,108,106,105,104,104,103,104,105,104,105,104,107,109,6,
  105,105,105,106,106,105,110,110,255,0,32,100,100,106,106,106,105,105,105,105,
  105,107,106,105,105,105,101,103,104,103,104,106,105,105,105,96,94,92,90,88,
  105,105,106,109,109,255,0,32,100,100,106,106,109,110,103,99,104,104,104,105,
  104,104,105,101,101,108,105,104,103,104,101,106,95,94,92,90,88,111,105,106,
  109,109,255,0,32,99,99,105,105,105,106,105,105,104,104,104,105,104,101,107,
  108,101,105,101,104,104,104,104,104,105,5,92,111,111,5,105,105,109,109,255,0,
  32,97,97,103,104,102,103,104,103,104,105,104,104,105,104,101,104,103,98,98,
  104,105,104,105,106,105,104,92,111,102,104,104,105,109,109,255,0,32,98,98,
  104,104,104,104,101,101,102,101,103,101,102,104,104,104,105,108,105,103,105,
  104,104,104,105,104,92,111,102,104,105,105,109,109,255,0,32,98,98,105,104,
  105,105,104,104,102,102,102,105,102,104,103,104,104,104,101,101,101,102,104,
  104,95,94,92,90,88,105,104,104,109,109,255,0,32,100,100,105,103,104,105,105,
  104,103,103,102,102,104,104,105,105,103,102,104,102,104,104,104,102,96,94,92,
  90,88,111,104,105,109,109,255,0,32,100,100,105,101,104,105,106,104,101,102,
  103,104,101,102,105,105,105,105,101,105,101,101,104,101,99,111,111,111,111,
  111,104,105,108,108,255,0,32,99,99,105,104,104,105,105,104,104,104,102,102,
  103,101,105,105,105,104,105,103,106,106,101,104,103,103,101,104,103,104,104,
  104,109,109,255,0,32,99,99,104,104,101,104,103,101,101,100,102,104,101,104,
  105,103,101,104,104,101,105,106,103,101,103,102,105,105,104,104,104,102,109,
  109,255,0,32,99,99,102,103,103,104,104,101,102,102,102,101,103,105,104,104,
  104,104,105,104,107,104,105,106,108,107,105,105,107,108,108,105,109,109,255,
  0,32,98,98,101,102,103,104,103,101,102,103,103,104,104,103,104,105,104,104,
  104,103,104,105,104,101,105,102,104,105,105,106,105,105,107,107,255,0,32,96,
  96,102,102,103,103,103,102,103,103,101,103,104,103,104,102,103,103,104,103,
  104,102,103,104,104,105,105,105,105,102,103,105,105,105,255,0,32,96,96,100,
  102,101,99,101,100,101,101,101,100,98,99,100,101,100,100,98,99,100,101,100,
  101,101,101,104,104,101,101,102,101,106,106,255,0,32,97,97,101,98,98,100,101,
  101,101,101,100,98,99,98,98,100,98,99,100,101,101,99,100,100,101,101,101,100,
  100,100,100,99,107,107,255,0,32,96,96,101,99,101,101,101,99,98,98,100,98,100,
  100,99,99,99,98,98,100,98,98,100,104,102,101,101,100,101,100,100,100,107,107,
  255,0,32,109,109,109,110,111,111,109,110,110,111,110,110,111,111,111,111,110,
  110,109,109,109,109,111,110,111,111,111,111,111,111,111,111,107,107,255,0,32,
  98,98,98,98,100,98,98,100,104,100,99,100,100,101,103,101,104,101,99,101,103,
  96,98,100,103,100,102,101,102,102,101,101,108,108,255,0,32,88,88,93,95,93,95,
  94,95,95,94,94,95,95,95,95,95,95,95,95,95,95,95,95,95,95,94,94,95,95,95,95,
  95,107,107,255,0,32,93,93,101,103,100,100,103,100,101,101,101,101,103,103,
  101,100,101,101,103,100,103,101,101,101,101,101,100,103,103,103,103,100,108,
  108,255,0,32,97,97,101,100,100,101,104,105,101,103,101,103,101,101,101,105,
  101,101,101,103,100,101,103,101,103,103,103,103,103,100,103,103,109,109,255,
  0,32,98,98,103,103,103,103,103,103,103,103,103,101,101,101,103,103,103,103,
  101,101,103,101,103,103,103,103,103,101,103,103,103,103,108,108,255,0,32,98,
  98,103,103,103,103,103,103,103,103,103,103,103,103,103,103,103,103,103,103,
  103,103,103,103,104,94,92,90,88,102,103,103,109,109,255,0,32,99,99,106,105,
  105,105,104,105,105,102,104,103,103,103,104,105,105,104,105,105,106,105,105,
  103,96,94,92,90,88,5,105,103,109,109,255,0,32,100,100,101,105,103,105,104,
  101,103,104,105,104,104,105,106,108,107,107,105,106,105,105,105,105,95,5,92,
  6,5,5,105,105,109,109,255,0,32,100,100,106,108,105,105,105,105,104,104,105,
  105,105,106,104,105,104,105,107,105,105,108,105,105,96,6,92,5,105,105,105,
  105,109,109,255,0,32,100,100,105,106,106,106,105,105,104,104,105,104,105,105,
  106,105,105,105,105,106,105,105,105,106,96,5,92,5,107,107,105,106,109,109,
  255,0,32,100,100,101,104,104,104,104,106,106,104,106,103,105,105,104,105,108,
  105,105,105,103,105,106,105,96,6,92,6,107,105,106,105,109,109,255,0,32,101,
  101,106,104,104,106,104,104,105,105,104,105,106,105,104,105,104,108,103,105,
  105,105,104,104,109,6,108,6,105,105,104,104,109,109,255,0,32,100,100,103,101,
  102,105,106,106,107,104,105,103,104,104,106,105,105,105,107,106,105,105,101,
  105,96,101,92,90,88,102,101,105,110,110,255,0,32,99,99,104,103,104,103,105,
  104,103,104,104,103,103,105,106,105,104,104,101,104,104,103,104,104,96,111,
  92,90,88,111,104,104,109,109,255,0,32,99,99,103,103,102,103,102,103,103,102,
  105,104,104,104,104,105,105,104,104,104,104,103,105,104,95,111,92,111,111,
  111,105,104,108,108,255,0,32,97,97,102,101,102,105,101,101,101,101,102,102,
  102,104,104,103,104,107,107,106,101,104,104,101,96,111,92,111,104,105,104,
  101,108,108,255,0,32,99,99,101,101,101,102,101,101,102,102,104,104,104,105,
  105,105,104,104,104,104,105,104,101,101,96,94,92,90,88,102,101,101,109,109,
  255,0,32,100,100,103,103,106,105,107,105,106,103,104,104,101,101,102,102,103,
  104,105,104,105,105,105,104,104,94,111,90,88,111,105,104,109,109,255,0,32,
  100,100,103,101,104,104,102,103,102,104,105,105,105,103,101,102,105,105,104,
  105,103,104,104,102,106,104,111,105,111,111,104,102,109,109,255,0,32,100,100,
  107,108,107,106,105,104,101,102,101,104,105,107,105,103,103,104,105,101,102,
  105,105,106,105,106,92,90,88,109,105,106,109,109,255,0,32,97,97,103,103,103,
  101,103,104,106,106,104,104,103,101,105,104,105,105,102,102,104,104,104,104,
  109,94,92,90,88,6,104,104,107,107,255,0,32,101,101,101,101,100,101,101,101,
  101,101,103,104,105,106,105,105,104,105,106,107,106,106,106,104,96,94,92,6,6,
  6,106,104,109,109,255,0,32,100,100,105,105,104,102,103,103,101,101,104,102,
  101,102,101,101,102,104,104,105,104,106,108,106,95,6,92,5,105,105,108,106,
  109,109,255,0,32,99,99,105,105,104,106,106,106,105,105,104,102,103,101,102,
  103,104,105,101,102,105,104,102,104,96,94,92,90,88,108,102,104,109,109,255,0,
  32,99,99,104,104,104,104,105,104,105,106,105,105,105,105,105,106,105,104,106,
  108,105,105,105,106,106,94,92,90,88,6,105,106,109,109,255,0,32,98,98,101,102,
  103,102,103,101,102,102,103,103,103,103,104,103,103,104,104,104,104,105,104,
  105,107,109,6,6,6,6,101,101,109,109,255,0,32,98,98,103,102,102,101,102,102,
  103,101,103,103,103,102,102,102,104,104,103,104,104,104,103,103,103,94,92,90,
  104,105,101,103,108,108,255,0,32,100,100,103,104,103,105,104,103,103,102,101,
  103,103,104,105,105,103,104,104,104,104,104,104,103,96,94,92,90,88,105,105,
  104,109,109,255,0,32,101,101,105,105,105,105,105,105,105,106,105,104,105,108,
  109,108,107,106,107,106,108,108,107,106,95,111,111,111,88,5,108,106,110,110,
  255,0,32,100,100,104,105,107,108,105,105,108,106,105,107,108,108,109,105,105,
  105,103,106,105,105,105,105,96,111,105,105,88,111,105,105,110,110,255,0,32,
  102,102,104,105,105,104,103,105,105,103,104,107,110,107,105,106,105,105,105,
  106,105,106,105,102,96,111,92,103,88,111,106,108,5,5,255,0,32,101,101,104,
  104,103,103,103,106,107,105,105,105,109,106,102,108,106,106,107,105,105,106,
  106,104,96,111,92,90,88,111,105,108,111,111,255,0,32,100,100,105,105,105,106,
  105,104,105,104,104,105,106,110,102,104,106,106,105,103,105,107,106,107,101,
  111,92,90,111,111,106,107,5,5,255,0,32,99,99,107,109,105,105,101,104,104,103,
  104,105,105,108,105,104,104,106,105,104,104,107,106,105,103,103,111,111,111,
  104,106,106,5,5,255,0,32,99,99,101,105,99,101,105,104,102,104,104,104,105,
  105,102,101,101,101,103,105,104,105,105,106,105,105,104,107,106,105,107,105,
  5,5,255,0,32,101,101,109,106,104,105,105,105,105,106,105,105,104,107,106,105,
  107,105,108,106,105,105,105,105,105,105,102,105,105,105,106,106,5,5,255,0,32,
  98,98,105,102,105,105,105,105,105,105,102,105,105,105,106,106,105,104,105,
  109,108,105,108,105,104,105,107,109,110,109,109,110,5,5,255,0,32,92,92,98,98,
  98,99,99,99,99,99,98,99,99,99,99,99,99,99,99,100,100,99,100,99,99,99,99,100,
  101,100,100,101,5,5,255,0,32,93,93,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
  7,7,7,7,7,7,7,7,7,7,7,255,0,32,93,93,7,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,
  5,5,5,5,5,5,5,5,5,5,5,5,255,0,32,91,91,7,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,
  5,5,5,5,5,5,5,5,5,5,5,5,5,255,0,32,91,91,7,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,
  5,5,5,5,5,5,5,5,5,5,5,5,5,5,255,0,32,91,91,7,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,
  5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,255,0,32,91,91,7,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,
  5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,255,0,32,91,91,7,5,5,5,5,5,5,5,5,5,5,5,5,5,5,
  5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,255,0,32,91,91,7,5,5,5,5,5,5,5,5,5,5,5,5,5,
  5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,255,0,32,91,91,7,5,5,5,5,5,5,5,5,5,5,5,5,
  5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,255,0,32,91,91,7,5,5,5,5,5,5,5,5,5,5,5,
  5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,255,0,32,91,91,7,5,5,5,5,5,5,5,5,5,5,
  5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,255,0,32,91,91,7,5,5,5,5,5,5,5,5,5,
  5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,255,0,32,91,91,7,5,5,5,5,5,5,5,5,
  5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,255,0,32,91,91,7,5,5,5,5,5,5,5,
  5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,255,0,32,91,91,7,5,5,5,5,5,5,
  5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,255,0,32,91,91,7,5,5,5,5,5,
  5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,255,0,32,91,91,7,5,5,5,5,
  5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,255,0,32,91,91,7,5,5,5,
  5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,255,0,32,91,91,7,5,5,
  5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,255,0,32,91,91,7,5,
  5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,255,0,32,91,91,7,
  5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,255,0,32,91,91,
  7,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,255,0,32,91,
  91,7,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,255,0,32,
  91,91,7,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,255,0,
  32,91,91,7,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,255,
  0,32,91,91,7,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,
  255,0,32,91,91,7,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,
  5,255,0,32,91,91,7,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,
  5,5,255,0,32,91,91,7,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,
  5,5,5,255,0,32,91,91,7,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,
  5,5,5,5,255,0,32,91,91,7,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,
  5,5,5,5,5,255,0,32,91,91,7,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,
  5,5,5,5,5,5,255,0,32,93,93,7,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,
  5,5,5,5,5,5,5,255,0,32,91,91,7,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,
  5,5,5,5,5,5,5,5,255,0,32,91,91,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
  7,7,7,7,7,7,7,7,7,255,0,32,92,92,94,95,96,96,96,96,95,95,96,96,96,96,96,96,
  96,95,95,96,97,96,95,96,96,96,96,95,94,96,96,96,107,107,255,0,32,94,94,103,
  102,104,104,101,101,101,102,104,101,103,100,102,103,101,103,104,103,105,103,
  102,104,104,101,101,101,101,103,104,104,109,109,255,0,32,94,94,103,101,103,
  102,104,103,100,105,102,104,101,102,102,104,104,103,99,101,102,103,101,103,
  102,104,103,100,102,103,104,101,107,107,255,0,32,96,96,99,97,101,99,98,101,
  98,98,100,102,101,100,98,98,103,107,105,105,103,100,103,101,99,98,101,98,101,
  104,104,104,108,108,255,0,32,97,97,99,99,97,97,97,98,101,99,100,101,100,100,
  98,103,103,99,100,100,98,100,100,96,97,97,98,101,102,104,104,101,109,109,255,
  0,32,97,97,100,99,99,97,97,101,103,99,98,98,99,100,98,101,98,100,100,101,101,
  100,99,99,99,97,101,103,101,98,103,103,108,108,255,0,32,95,95,99,98,102,101,
  103,101,102,98,96,98,101,98,98,100,99,98,101,97,97,99,98,102,101,103,101,102,
  105,104,100,104,107,107,255,0,32,96,96,99,99,103,100,103,101,103,96,98,101,
  98,98,100,99,103,101,100,97,99,99,99,103,100,103,101,103,105,105,98,102,104,
  104,255,0,32,97,97,100,100,100,98,101,104,110,101,98,100,99,98,99,98,100,98,
  100,101,101,100,100,100,98,101,104,110,110,102,98,101,108,108,255,0,32,97,97,
  104,100,100,101,103,101,104,101,106,102,100,99,98,100,101,98,100,101,101,104,
  100,100,101,103,104,101,104,101,103,97,108,108,255,0,32,98,98,105,105,104,
  104,101,103,101,104,102,100,99,99,100,99,101,101,104,102,103,105,105,104,104,
  101,92,90,88,101,99,103,109,109,255,0,32,98,98,103,103,103,104,104,103,103,
  103,100,103,103,103,103,103,103,103,103,103,103,103,103,103,103,94,92,90,88,
  111,103,103,107,107,255,0,32,98,98,103,103,103,103,103,103,104,103,103,103,
  103,103,101,103,103,103,103,100,103,101,103,103,96,94,92,111,111,111,103,104,
  108,108,255,0,32,98,98,103,103,103,103,103,103,103,103,103,103,103,103,103,
  101,100,101,101,103,100,100,100,103,96,111,92,111,101,101,103,101,108,108,
  255,0,32,99,99,103,103,103,103,104,104,104,104,103,103,103,104,103,104,104,
  103,103,103,103,103,103,103,95,94,92,90,88,103,103,103,109,109,255,0,32,98,
  98,104,103,105,103,104,103,103,103,101,103,103,103,105,103,103,104,103,103,
  104,103,104,104,103,94,92,90,88,111,103,103,109,109,255,0,32,99,99,102,103,
  103,104,104,101,102,102,102,101,103,105,104,104,104,104,105,104,107,104,105,
  106,108,107,5,5,6,6,108,105,109,109,255,0,32,98,98,101,102,103,104,103,101,
  102,103,103,104,104,103,104,105,104,104,104,103,104,105,104,101,96,102,92,90,
  88,106,105,105,107,107,255,0,32,96,96,102,102,103,103,103,102,103,103,101,
  103,104,103,104,102,103,103,104,103,104,102,103,104,95,5,92,90,88,111,103,
  105,105,105,255,0,32,96,96,100,102,101,99,101,100,101,101,101,100,98,99,100,
  101,100,100,98,99,100,101,100,101,96,111,92,111,111,111,102,101,106,106,255,
  0,32,97,97,101,98,98,100,101,101,101,101,100,98,99,98,98,100,98,99,100,101,
  101,99,100,100,96,111,92,109,100,100,100,99,107,107,255,0,32,96,96,101,99,
  101,101,101,99,98,98,100,98,100,100,99,99,99,98,98,100,98,98,100,104,96,94,
  92,90,88,100,100,100,107,107,255,0,32,95,95,99,100,101,101,99,100,100,101,
  100,100,101,103,101,101,100,100,99,99,98,97,101,100,101,94,111,90,88,111,101,
  101,107,107,255,0,32,96,96,98,98,100,98,98,100,104,100,99,100,100,101,103,
  101,104,101,99,101,103,96,98,100,103,100,111,101,111,111,101,101,108,108,255,
  0,32,97,97,103,101,101,101,100,103,101,100,100,101,103,101,103,103,101,103,
  103,103,101,101,101,101,101,94,92,90,88,101,101,101,107,107,255,0,32,99,99,
  103,101,98,98,101,103,103,101,101,103,103,103,103,103,103,103,103,103,103,
  103,103,103,96,94,92,90,88,111,103,103,108,108,255,0,32,97,97,103,101,103,
  103,101,101,103,104,103,103,103,103,103,103,103,101,103,103,101,101,103,103,
  103,94,92,111,111,111,103,101,109,109,255,0,32,98,98,103,103,103,104,104,103,
  101,101,100,103,103,103,103,103,104,103,103,103,103,103,103,103,101,103,92,
  90,101,103,103,103,108,108,255,0,32,98,98,103,103,103,103,103,104,104,103,
  103,104,104,103,103,103,104,103,103,101,103,101,103,103,103,94,92,111,111,
  103,103,104,109,109,255,0,32,99,99,105,104,104,103,103,103,103,103,103,103,
  104,102,103,102,101,102,102,103,101,101,101,102,96,94,92,90,88,102,104,102,
  109,109,255,0,32,100,100,104,105,105,105,104,104,106,106,103,105,104,106,105,
  106,106,104,104,104,103,103,102,104,106,94,92,90,88,111,104,104,109,109,255,
  0,32,100,100,106,105,107,105,106,104,104,105,102,104,104,105,107,105,105,106,
  105,105,106,104,106,106,104,105,5,6,6,5,104,104,109,109,255,0,32,100,100,104,
  105,105,104,104,105,105,105,105,105,104,105,105,105,104,105,105,103,103,103,
  103,103,103,94,92,90,104,105,105,105,109,109,255,0,32,100,100,105,105,104,
  105,104,105,104,104,104,105,105,105,104,105,105,104,104,103,105,104,104,104,
  96,94,92,90,88,105,104,105,108,108,255,0,32,99,99,103,105,104,104,103,103,
  104,103,104,104,104,104,103,104,104,104,103,103,103,103,103,103,95,111,111,
  111,88,5,105,105,109,109,255,0,32,98,98,103,101,107,105,105,103,103,103,104,
  104,104,103,104,104,103,103,103,103,103,104,104,103,96,111,103,103,88,111,
  103,103,109,109,255,0,32,98,98,103,103,103,103,103,104,103,104,103,103,103,
  103,104,104,104,104,103,103,103,103,103,103,96,111,103,103,88,111,104,104,
  109,109,255,0,32,98,98,103,104,103,103,100,103,103,103,103,103,103,103,103,
  103,103,103,103,103,101,101,103,103,96,94,92,90,88,111,103,104,108,108,255,0,
  32,99,99,103,103,103,104,103,101,101,101,103,103,103,103,103,103,103,100,101,
  101,100,103,103,103,101,94,92,90,111,111,103,104,107,107,255,0,32,98,98,103,
  103,104,103,105,104,102,102,102,102,102,101,100,102,105,104,102,101,101,101,
  105,102,103,103,111,111,111,104,101,102,107,107,255,0,32,99,99,103,102,102,
  101,101,101,99,101,101,101,102,101,102,100,101,101,102,100,98,101,101,102,96,
  101,92,90,88,102,102,101,105,105,255,0,32,100,100,102,102,102,103,101,102,
  102,103,103,102,101,102,101,101,102,102,100,100,100,102,101,102,96,111,92,90,
  88,111,105,101,108,108,255,0,32,98,98,103,103,103,103,105,105,103,103,104,
  102,102,102,102,102,101,102,101,101,101,101,101,101,95,111,92,111,111,111,
  103,99,108,108,255,0,32,98,98,103,103,103,103,104,105,105,103,105,104,106,
  106,106,106,105,102,104,105,101,101,104,105,96,111,92,111,104,105,102,102,
  108,108,255,0,32,99,99,103,101,105,105,104,104,104,104,104,104,104,102,103,
  102,102,101,101,101,104,101,102,102,96,94,92,90,88,102,103,102,109,109,255,0,
  32,99,99,105,104,104,104,101,104,102,103,103,103,104,102,103,102,101,102,102,
  103,101,101,101,102,104,94,111,90,88,111,104,102,109,109,255,0,32,100,100,
  104,105,105,105,104,104,106,106,103,105,104,106,105,106,106,104,104,104,103,
  103,102,104,106,104,111,105,111,111,104,104,111,111,255,0,32,100,100,106,105,
  107,105,106,104,104,105,102,104,104,105,107,105,105,106,105,105,106,104,106,
  106,104,105,106,108,108,106,104,104,109,109,255,0,32,97,97,101,103,102,103,
  102,102,102,103,102,102,103,104,103,104,102,102,103,103,102,104,108,107,107,
  107,105,105,105,105,104,107,109,109,255,0,32,98,98,103,102,103,103,102,102,
  103,102,103,103,104,104,103,103,103,104,104,104,104,105,105,105,107,105,105,
  105,104,102,104,105,5,5,255,0,32,99,99,102,102,102,102,101,103,102,101,103,
  103,103,104,103,104,103,105,105,105,103,101,103,101,105,107,105,107,107,105,
  105,105,111,111,255,0,32,99,99,102,102,102,102,101,103,102,101,103,103,103,
  104,103,104,103,105,105,105,103,101,103,101,105,107,105,107,107,105,105,105,
  111,111,255,0,32,100,100,104,104,104,103,104,104,105,105,102,104,104,107,105,
  105,109,106,105,105,105,108,108,107,109,110,108,109,109,110,108,110,111,111,
  255,0,32,100,100,104,105,108,104,103,104,104,104,104,105,106,105,106,108,108,
  105,105,107,108,109,108,106,105,106,109,108,109,109,108,108,111,111,255,0,32,
  97,97,99,104,104,105,102,104,104,105,105,105,104,102,104,103,101,106,106,107,
  107,108,108,108,109,108,109,108,108,108,108,108,111,111,255,0,32,97,97,104,
  104,103,104,101,102,101,104,105,104,104,103,104,104,104,105,105,105,104,107,
  109,108,109,109,109,108,108,107,107,107,5,5,255,0,32,97,97,104,104,102,104,
  104,104,104,104,104,104,101,101,105,104,105,105,105,105,107,109,109,109,109,
  109,109,106,105,105,107,108,111,111,255,0,32,109,109,5,5,5,5,5,5,111,5,5,5,5,
  5,5,5,5,5,6,6,6,6,6,6,5,5,5,5,6,6,6,6,6,6,255,0,32,104,104,104,104,103,103,
  105,105,105,104,105,105,105,105,106,105,105,108,108,108,108,105,108,106,106,
  106,108,108,110,110,109,107,5,5,255,0,32,108,108,105,96,100,100,100,101,99,
  100,100,102,105,96,100,100,100,100,101,100,100,110,108,102,101,102,102,102,
  102,101,101,111,111,111,255,0,32,104,104,104,100,105,105,105,104,104,108,106,
  109,105,100,106,107,108,108,107,107,106,111,106,101,108,106,108,109,109,109,
  109,5,111,111,255,0,32,101,101,101,99,105,105,105,98,105,107,105,5,106,100,
  106,107,107,106,106,106,106,109,107,101,107,109,109,110,109,109,106,111,110,
  110,255,0,32,101,101,105,100,108,103,103,101,108,105,105,5,106,100,105,107,
  106,107,109,109,109,111,109,101,107,107,107,108,107,107,109,111,109,109,255,
  0,32,104,104,104,99,104,102,102,104,104,104,106,5,106,99,104,104,104,104,106,
  106,106,109,106,99,104,106,106,106,106,104,102,109,108,108,255,0,32,100,100,
  104,98,101,101,101,100,100,101,101,111,104,97,104,103,103,103,101,104,104,
  109,101,99,104,103,103,104,103,103,101,107,107,107,255,0,32,103,103,106,99,
  104,103,103,103,106,103,106,111,104,99,103,103,101,101,101,101,100,109,103,
  98,103,103,103,104,103,103,103,108,107,107,255,0,32,101,101,100,96,101,103,
  103,101,100,101,100,110,104,96,100,100,103,103,101,100,103,106,101,98,102,
  103,104,103,103,103,101,107,109,109,255,0,32,101,101,104,97,103,100,100,101,
  100,103,101,111,108,99,101,103,104,100,103,104,103,110,106,97,100,103,104,
  104,103,103,103,107,109,109,255,0,32,103,103,101,98,104,103,103,103,103,103,
  104,5,106,98,103,103,103,103,104,106,106,110,106,100,3,106,106,104,106,104,
  104,109,110,110,255,0,32,106,106,110,107,110,110,110,110,110,111,111,5,108,
  110,5,5,5,111,5,5,5,109,104,6,6,6,5,5,5,5,5,5,110,110,255,0,32,105,105,106,
  106,106,105,105,105,105,105,107,106,105,105,105,101,103,104,103,104,106,105,
  105,105,109,104,106,106,105,105,105,106,109,109,255,0,32,94,94,96,96,98,98,
  95,94,96,96,96,96,96,96,96,95,95,97,96,96,95,96,95,96,96,96,96,96,96,96,96,
  96,109,109,255,0,32,99,99,105,105,105,106,105,105,104,104,104,105,104,101,
  107,108,101,105,101,104,104,104,104,104,105,105,101,102,102,105,105,105,109,
  109,255,0,32,97,97,103,104,102,103,104,103,104,105,104,104,105,104,101,104,
  103,98,98,104,105,104,105,106,105,104,104,104,102,104,104,105,109,109,255,0,
  32,98,98,104,104,104,104,101,101,102,101,103,101,102,104,104,104,105,107,103,
  105,103,105,105,103,105,104,104,104,102,104,105,105,109,109,255,0,32,98,98,
  105,104,105,105,104,104,102,102,102,105,102,104,103,104,104,103,103,101,103,
  104,102,104,102,104,105,103,102,105,104,104,109,109,255,0,32,100,100,105,103,
  104,105,95,94,92,90,88,102,104,94,105,105,88,104,95,94,92,90,88,105,104,94,
  92,90,104,104,104,105,109,109,255,0,32,100,100,105,101,104,105,96,111,92,111,
  88,104,96,111,92,105,88,104,95,111,92,111,111,103,96,5,111,111,88,104,104,
  105,108,108,255,0,32,99,99,105,104,104,105,96,104,92,104,88,102,96,101,92,
  105,88,101,95,101,92,101,102,104,96,103,106,106,88,104,104,104,109,109,255,0,
  32,99,99,104,104,101,104,111,94,111,90,111,104,96,104,5,90,111,104,107,94,
  109,90,88,101,95,101,105,106,88,104,104,102,109,109,255,0,32,99,99,102,103,
  103,104,104,111,102,111,102,101,111,105,104,111,104,104,101,110,104,111,111,
  104,5,104,107,104,5,108,108,105,109,109,255,0,32,98,98,101,102,103,104,96,94,
  92,90,103,104,96,94,92,90,88,102,104,94,92,90,104,101,96,94,92,90,88,106,105,
  105,107,107,255,0,32,96,96,102,102,103,103,111,111,111,111,88,103,111,111,92,
  111,111,105,96,5,111,111,88,104,96,111,92,111,88,102,103,105,105,105,255,0,
  32,96,96,100,102,101,99,101,100,101,101,88,100,98,99,92,101,100,101,95,101,
  101,100,88,100,95,99,109,101,88,101,102,101,106,106,255,0,32,97,97,101,98,98,
  100,95,94,92,90,109,98,95,94,92,90,88,100,111,98,99,100,111,100,109,101,101,
  99,109,100,100,99,107,107,255,0,32,96,96,101,99,101,101,111,109,109,109,100,
  98,109,109,109,109,109,100,96,94,92,90,88,100,96,94,92,90,88,100,100,100,107,
  107,255,0,32,95,95,99,100,101,101,96,94,92,90,88,100,96,94,92,90,88,101,111,
  111,92,111,111,101,109,109,109,109,88,102,101,101,107,107,255,0,32,96,96,98,
  98,100,98,109,109,111,109,88,100,96,111,92,111,88,98,98,94,111,90,98,98,99,
  101,103,96,88,102,101,101,108,108,255,0,32,97,97,103,101,101,101,100,103,101,
  100,88,101,95,101,111,103,88,101,96,111,101,111,88,101,103,103,101,101,111,
  101,101,101,107,107,255,0,32,99,99,103,101,98,98,101,103,103,101,111,103,111,
  103,103,103,111,103,111,101,101,101,111,101,96,94,92,90,88,103,103,103,108,
  108,255,0,32,97,97,103,101,103,103,96,94,92,90,88,103,96,94,92,90,88,101,93,
  100,101,103,101,103,111,111,111,111,88,103,103,101,109,109,255,0,32,98,98,
  103,103,103,104,111,111,111,111,88,103,111,111,111,111,88,101,96,94,92,90,88,
  103,103,103,103,103,88,103,103,103,108,108,255,0,32,98,98,103,103,103,103,
  103,104,104,103,88,104,104,103,103,103,88,103,96,110,110,110,110,103,103,101,
  103,101,111,103,103,104,109,109,255,0,32,99,99,105,104,104,103,103,103,103,
  103,111,103,104,102,103,102,111,105,110,106,105,105,103,105,105,104,105,106,
  105,102,104,102,109,109,255,0,32,100,100,104,105,105,105,104,104,106,106,103,
  105,104,106,105,106,106,105,106,105,105,105,105,106,106,104,103,105,104,104,
  104,104,111,111,255,0,32,100,100,106,105,107,105,106,104,104,105,102,104,104,
  105,107,105,105,107,105,105,108,105,105,104,104,105,106,108,108,106,104,104,
  109,109,255,0,32,100,100,105,104,104,105,104,104,104,105,106,105,104,105,105,
  105,104,105,106,105,105,105,106,105,104,104,105,103,104,105,108,107,109,109,
  255,0,32,100,100,104,105,107,104,104,104,104,104,104,104,104,105,105,101,104,
  105,104,102,101,101,102,102,101,101,104,105,104,104,105,105,109,109,255,0,32,
  101,101,105,105,102,105,105,107,104,105,104,106,106,107,105,106,106,104,104,
  103,105,105,106,106,104,104,105,104,104,105,104,104,111,111,255,0,32,100,100,
  105,106,105,105,105,105,108,104,106,105,105,105,105,108,104,106,106,104,102,
  104,104,104,104,105,106,107,105,107,106,105,111,111,255,0,32,99,99,105,105,
  107,106,106,102,105,101,105,106,105,105,106,105,105,105,105,105,105,104,104,
  104,104,103,104,104,103,105,104,108,109,109,255,0,32,99,99,104,103,105,105,
  106,106,103,104,104,104,104,105,105,107,106,106,102,102,102,101,104,104,103,
  99,103,104,105,105,107,107,109,109,255,0,32,97,97,104,103,101,104,104,104,
  103,105,104,103,104,104,103,105,105,106,106,106,106,101,101,104,106,107,105,
  106,105,105,105,105,5,5,255,0,32,99,99,101,103,103,101,103,102,104,104,101,
  102,101,104,103,101,104,104,104,104,104,108,105,102,101,103,101,103,102,103,
  103,104,111,111,255,0,32,100,100,106,104,104,104,103,105,104,101,101,104,104,
  101,103,103,101,103,102,102,102,104,104,105,104,103,107,108,108,109,110,110,
  109,109,255,0,32,100,100,104,104,102,105,104,104,105,105,104,105,105,106,104,
  104,104,103,105,105,105,102,104,105,107,109,107,105,108,108,108,107,109,109,
  255,0,32,100,100,105,105,105,105,106,106,104,104,102,105,105,104,104,102,105,
  104,104,104,104,103,108,108,107,105,102,103,103,104,102,105,109,109,255,0,32,
  97,97,101,104,102,104,104,104,105,105,106,105,105,105,105,105,105,106,106,
  106,106,104,105,108,108,105,105,104,103,104,105,105,109,109,255,0,32,101,101,
  107,102,104,102,104,103,104,104,104,101,101,101,104,102,104,104,104,104,104,
  107,106,108,105,108,109,105,105,105,107,105,109,109,255,0,32,100,100,106,105,
  105,105,105,106,106,106,104,105,102,102,102,104,102,104,103,103,103,103,104,
  101,104,104,104,105,105,107,107,105,5,5,255,0,32,99,99,105,106,105,105,104,
  105,106,108,106,105,106,106,105,105,105,105,106,106,106,106,106,106,105,104,
  105,105,106,105,105,104,109,109,255,0,32,99,99,104,104,104,105,104,104,104,
  102,104,105,104,105,106,105,105,104,105,105,105,107,105,106,107,108,105,106,
  106,105,105,109,10,10,255,0,32,98,98,103,103,103,104,104,103,103,102,104,103,
  103,104,104,104,104,104,104,104,103,103,105,107,107,107,107,105,107,159,107,
  105,111,111,255,0,32,98,98,103,103,105,105,105,105,104,105,105,104,107,105,
  105,105,104,157,105,105,104,104,107,105,107,107,107,107,109,107,107,158,5,5,
  255,0,32,100,100,105,104,105,105,105,159,110,107,88,105,105,107,107,105,88,
  105,103,105,107,104,88,105,103,105,107,107,88,107,105,107,5,5,255,0,32,101,
  101,109,109,106,107,109,109,108,90,6,109,110,108,109,90,6,106,107,107,109,90,
  6,108,108,110,110,90,127,109,110,109,5,5,255,0,32,100,100,106,108,109,106,
  106,106,92,6,109,109,108,110,92,6,106,106,109,109,92,6,109,110,109,110,92,6,
  109,109,110,109,5,5,255,0,32,102,102,107,109,109,106,106,94,6,109,109,109,
  109,94,6,109,109,106,109,94,6,110,110,110,109,94,6,109,109,109,110,110,5,5,
  255,0,32,101,101,106,106,109,106,96,6,108,109,109,107,96,6,106,102,109,109,
  96,6,109,109,109,106,95,6,109,110,110,109,109,110,5,5,255,0,32,106,106,108,
  109,106,106,5,105,106,107,107,107,6,106,103,101,108,108,6,107,108,107,105,
  104,5,107,108,110,110,109,109,110,5,5,255,0,32,104,104,109,109,108,105,105,
  106,105,106,106,108,108,106,108,106,108,106,107,107,107,107,108,106,108,109,
  109,109,109,109,110,110,5,5,255,0,32,99,99,109,106,104,105,105,106,105,105,
  104,107,106,105,107,105,108,106,107,105,107,107,108,108,108,109,110,109,106,
  109,107,109,5,5,255,0,32,101,101,105,102,105,105,105,105,105,105,102,105,105,
  105,106,106,105,104,105,109,108,105,108,105,104,105,107,109,110,109,109,110,
  5,5,255,0,32,98,98,104,102,104,105,106,105,104,104,104,105,105,106,105,105,
  105,108,109,110,105,105,105,105,105,105,106,109,108,109,110,110,5,5,255,0,32,
  100,100,102,102,104,105,105,104,104,104,105,105,105,105,106,105,105,108,108,
  107,107,108,108,109,108,108,109,110,109,110,109,110,110,110,255,0,32,99,99,
  102,104,105,105,105,104,104,101,104,105,106,105,105,106,105,107,107,107,107,
  108,110,109,108,109,109,110,110,110,109,110,109,109,255,0,32,98,98,102,102,
  102,102,104,102,106,104,102,104,104,104,106,104,104,104,104,104,106,104,104,
  104,104,106,108,110,110,106,104,106,5,5,255,0,32,99,99,106,102,102,101,104,
  104,106,104,106,101,102,106,104,104,106,104,104,104,104,106,106,106,106,106,
  106,106,106,106,104,104,5,5,255,0,32,100,100,106,105,104,105,104,105,104,106,
  105,105,105,107,107,105,105,105,106,106,106,106,106,106,107,108,106,106,106,
  107,106,109,111,111,255,0,32,99,99,105,105,104,104,108,104,101,105,105,104,
  104,107,107,106,105,105,105,106,108,108,107,109,108,109,109,107,107,107,107,
  109,111,111,255,0,32,100,100,103,101,103,104,105,105,104,104,107,107,104,105,
  107,106,105,107,108,109,108,106,108,123,108,106,109,109,108,106,107,107,5,5,
  255,0,32,100,100,102,104,104,105,106,106,106,105,105,105,106,107,104,105,108,
  105,105,106,107,108,108,109,108,106,107,108,107,109,109,108,111,111,255,0,32,
  101,101,104,104,105,104,105,105,105,103,105,105,105,108,105,105,107,109,106,
  105,106,108,107,107,105,109,109,108,108,107,108,109,5,5,255,0,32,95,95,100,
  102,103,101,101,103,105,102,105,105,104,104,105,106,105,107,108,106,105,105,
  105,105,106,108,106,107,109,110,109,108,111,111,255,0,32,97,97,102,102,102,
  102,105,103,102,101,102,104,104,105,105,105,105,105,105,104,105,105,104,105,
  106,109,109,108,108,108,109,109,111,111,255,0,32,98,98,103,103,104,103,105,
  104,102,103,104,102,104,105,104,105,104,106,105,106,105,106,106,105,106,105,
  107,109,107,106,108,108,111,111,255,0,32,98,98,104,104,104,102,101,100,101,
  104,104,104,105,105,105,105,105,105,106,105,106,109,106,106,105,105,105,106,
  106,106,106,107,5,5,255,0,32,98,98,104,106,106,104,104,104,105,105,106,106,
  105,105,105,105,105,105,104,105,106,105,106,106,106,105,106,106,108,108,104,
  108,110,110,255,0,32,96,96,102,103,104,104,103,105,107,105,105,105,105,105,
  106,106,105,105,105,105,105,106,107,106,107,107,105,106,106,106,108,109,111,
  111,255,0,32,98,98,102,104,104,101,101,101,104,102,103,105,105,101,104,104,
  105,105,105,105,106,106,107,106,105,104,106,106,106,106,107,106,110,110,255,
  0,32,97,97,102,101,101,101,102,102,101,101,104,104,104,104,101,103,105,105,
  105,105,106,106,106,105,105,105,105,107,106,107,105,107,109,109,255,0,32,104,
  104,106,106,108,108,109,109,109,109,109,109,109,110,109,110,109,109,109,109,
  109,109,109,109,109,111,110,109,111,111,111,110,109,109,255,
};

static const char m_nmare[] = {  // nightmare mode menu item
  124,0,19,0,0,0,0,0,248,1,0,0,12,2,0,0,34,2,0,0,56,2,0,0,80,2,0,0,102,2,0,0,
  120,2,0,0,133,2,0,0,146,2,0,0,159,2,0,0,172,2,0,0,193,2,0,0,215,2,0,0,238,2,
  0,0,4,3,0,0,25,3,0,0,47,3,0,0,67,3,0,0,86,3,0,0,105,3,0,0,123,3,0,0,139,3,0,
  0,152,3,0,0,168,3,0,0,186,3,0,0,206,3,0,0,225,3,0,0,242,3,0,0,4,4,0,0,23,4,0,
  0,41,4,0,0,63,4,0,0,86,4,0,0,108,4,0,0,130,4,0,0,151,4,0,0,170,4,0,0,190,4,0,
  0,209,4,0,0,228,4,0,0,246,4,0,0,7,5,0,0,18,5,0,0,28,5,0,0,38,5,0,0,52,5,0,0,
  70,5,0,0,89,5,0,0,107,5,0,0,124,5,0,0,140,5,0,0,151,5,0,0,163,5,0,0,180,5,0,
  0,198,5,0,0,217,5,0,0,235,5,0,0,253,5,0,0,14,6,0,0,23,6,0,0,32,6,0,0,49,6,0,
  0,67,6,0,0,87,6,0,0,106,6,0,0,124,6,0,0,140,6,0,0,152,6,0,0,164,6,0,0,176,6,
  0,0,188,6,0,0,203,6,0,0,221,6,0,0,240,6,0,0,2,7,0,0,19,7,0,0,34,7,0,0,45,7,0,
  0,59,7,0,0,74,7,0,0,88,7,0,0,102,7,0,0,114,7,0,0,128,7,0,0,143,7,0,0,161,7,0,
  0,180,7,0,0,200,7,0,0,219,7,0,0,236,7,0,0,253,7,0,0,15,8,0,0,34,8,0,0,53,8,0,
  0,73,8,0,0,92,8,0,0,105,8,0,0,118,8,0,0,131,8,0,0,147,8,0,0,164,8,0,0,183,8,
  0,0,203,8,0,0,221,8,0,0,235,8,0,0,247,8,0,0,5,9,0,0,22,9,0,0,41,9,0,0,59,9,0,
  0,77,9,0,0,96,9,0,0,114,9,0,0,132,9,0,0,151,9,0,0,169,9,0,0,186,9,0,0,202,9,
  0,0,203,9,0,0,225,9,0,0,246,9,0,0,11,10,0,0,32,10,0,0,53,10,0,0,2,15,47,47,
  47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,255,1,17,47,47,181,179,180,182,
  179,177,182,182,182,180,180,183,185,185,187,47,47,255,0,17,47,47,178,177,180,
  180,180,179,178,181,181,183,184,184,185,186,187,41,41,255,0,19,47,47,178,177,
  179,179,179,181,182,180,182,185,183,180,180,183,185,187,47,47,47,255,1,17,47,
  47,178,178,179,181,182,183,185,186,185,184,185,185,185,38,47,47,47,255,2,13,
  47,47,181,183,184,185,184,186,47,47,47,47,47,47,47,255,3,8,47,47,181,184,183,
  183,186,188,47,47,255,4,8,47,47,181,183,184,185,187,188,47,47,255,5,8,47,47,
  181,183,185,186,187,188,47,47,255,6,8,47,47,181,184,181,179,186,188,47,47,
  255,0,16,47,47,47,47,47,47,47,47,47,185,182,186,181,180,188,47,47,47,255,0,
  17,47,47,178,179,179,181,181,182,182,186,186,186,183,185,185,45,45,47,47,255,
  0,18,47,47,175,177,177,178,178,178,178,177,181,180,180,177,181,186,187,45,47,
  47,255,0,17,47,47,177,179,182,180,180,181,182,184,185,185,185,185,186,188,
  189,47,47,255,0,16,47,47,178,182,183,182,182,182,184,186,187,187,187,187,189,
  45,47,47,255,0,17,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,
  255,3,15,47,47,182,180,180,178,177,177,181,183,180,180,180,181,187,47,47,255,
  3,14,47,47,180,185,184,183,181,180,178,177,177,182,187,47,47,47,255,3,14,47,
  47,180,185,183,182,182,182,181,181,182,183,181,186,47,47,255,3,13,47,47,183,
  180,180,178,175,177,181,186,187,187,47,47,47,255,3,11,47,47,47,47,47,47,47,
  47,47,47,47,47,47,255,5,8,47,47,47,186,186,186,186,187,47,47,255,4,11,47,47,
  187,183,183,185,185,182,180,185,47,47,47,255,4,13,47,47,185,183,183,183,182,
  180,180,182,185,186,47,47,47,255,3,15,47,47,186,186,186,185,185,186,185,184,
  183,184,186,188,187,47,47,255,3,14,47,47,185,186,187,47,47,47,47,187,188,45,
  187,47,47,47,255,3,4,47,47,180,185,47,47,11,4,47,47,185,187,47,47,255,3,5,47,
  47,180,183,187,47,47,11,4,47,47,181,187,47,47,255,3,6,47,47,175,177,179,184,
  187,187,11,4,47,47,178,178,47,47,255,3,5,47,47,177,184,186,47,47,11,4,47,47,
  180,183,47,47,255,3,4,47,47,177,185,47,47,8,9,47,47,47,47,47,187,187,187,47,
  47,47,255,3,4,47,47,179,182,47,47,8,10,47,47,182,185,183,186,187,183,181,181,
  47,47,255,3,4,47,47,179,180,47,47,8,9,47,47,186,187,187,187,188,45,47,47,47,
  255,3,4,47,47,181,185,47,47,8,9,47,47,181,182,180,180,183,180,187,47,47,255,
  3,4,47,47,185,186,47,47,8,8,47,47,185,186,186,186,187,47,47,47,255,3,14,47,
  47,47,47,47,47,47,47,47,47,47,47,47,47,47,47,255,3,15,47,47,183,186,186,186,
  186,186,186,183,180,180,181,180,187,47,47,255,3,14,47,47,177,178,179,181,180,
  178,182,182,185,186,47,47,47,47,255,3,14,47,47,181,184,184,184,185,186,182,
  180,180,183,181,187,47,47,255,3,13,47,47,183,182,182,185,183,184,185,185,185,
  185,187,47,47,255,3,12,47,47,47,47,47,47,182,186,188,47,47,47,47,47,255,7,6,
  47,47,177,182,185,47,47,47,255,7,5,47,47,179,186,187,47,47,255,7,5,47,47,179,
  180,180,185,185,255,3,9,47,47,47,47,47,47,180,185,188,47,47,255,3,13,47,47,
  183,180,180,178,175,177,181,186,186,186,186,47,47,255,3,14,47,47,179,183,186,
  181,181,179,179,175,180,180,183,186,47,47,255,3,13,47,47,180,178,175,177,181,
  182,185,182,178,178,186,47,47,255,3,12,47,47,182,186,185,185,184,184,184,185,
  185,187,47,47,255,3,11,47,47,47,47,47,47,47,47,47,47,47,47,47,255,3,6,47,47,
  183,186,186,186,47,47,255,3,7,47,47,179,177,181,184,185,45,45,255,3,12,47,47,
  178,182,47,47,45,47,47,47,47,47,47,47,255,3,13,47,47,177,177,177,180,182,180,
  178,178,187,186,187,45,45,255,3,14,47,47,177,177,179,180,178,175,178,183,180,
  180,178,181,47,47,255,3,13,47,47,178,180,180,182,182,182,181,183,185,185,187,
  45,45,255,3,13,47,47,179,182,183,182,185,185,182,180,178,186,187,47,47,255,3,
  12,47,47,179,185,47,47,47,47,47,47,47,47,47,47,255,3,4,47,47,179,186,47,47,
  255,3,4,47,47,181,186,47,47,255,3,12,47,47,47,47,47,47,47,47,47,47,47,47,47,
  47,255,4,13,47,47,184,183,184,182,180,178,181,182,185,187,47,47,47,255,3,15,
  47,47,181,179,180,180,180,180,181,178,30,177,183,181,181,47,47,255,3,14,47,
  47,178,178,180,182,182,182,182,182,180,185,186,187,47,47,255,3,13,47,47,182,
  182,182,182,180,178,178,180,180,178,182,47,47,255,4,11,47,47,182,186,186,187,
  187,47,47,47,47,47,47,255,5,7,47,47,179,175,177,185,187,47,47,255,6,7,47,47,
  181,185,186,186,187,47,47,255,6,7,47,47,181,185,185,182,186,47,47,255,5,7,47,
  47,181,182,182,182,186,47,47,255,4,10,47,47,182,185,183,183,184,47,47,47,47,
  47,255,3,13,47,47,175,177,181,185,185,180,185,185,185,187,47,47,47,255,3,14,
  47,47,178,181,182,182,182,182,181,178,178,183,180,181,47,47,255,3,13,47,47,
  179,182,184,182,186,186,186,186,185,187,47,47,47,255,4,12,47,47,185,186,186,
  187,182,185,182,180,181,187,47,47,255,5,10,47,47,47,47,47,47,47,47,47,47,47,
  47,255,10,6,47,47,47,185,185,47,47,47,255,8,9,47,47,47,186,185,182,181,181,
  187,47,47,255,6,10,47,47,47,186,185,182,180,181,187,47,47,47,255,5,9,47,47,
  186,184,182,181,181,181,187,47,47,255,4,9,47,47,186,184,182,182,182,186,47,
  47,47,255,4,7,47,47,184,182,178,181,186,47,47,255,3,9,47,47,183,185,186,47,
  186,47,47,47,47,255,3,10,47,47,182,184,47,47,178,179,182,187,47,47,255,3,13,
  47,47,179,179,47,47,181,182,186,47,47,47,47,47,47,255,3,14,47,47,179,186,185,
  185,184,186,186,187,187,187,187,187,47,47,255,3,15,47,47,180,182,182,182,180,
  178,175,180,178,178,183,180,187,47,47,255,3,14,47,47,186,183,183,184,184,183,
  182,180,180,183,180,187,47,47,255,4,12,47,47,187,186,185,186,186,186,187,187,
  187,47,47,47,255,3,12,47,47,47,47,47,47,47,47,47,47,47,47,47,47,255,3,13,47,
  47,183,186,47,47,184,185,180,183,182,181,186,47,47,255,3,14,47,47,178,184,47,
  47,175,178,180,177,182,180,181,187,47,47,255,3,14,47,47,179,180,185,47,177,
  185,185,185,187,188,47,47,74,74,255,3,15,47,47,178,177,178,180,178,181,179,
  180,180,180,183,186,187,47,47,255,3,14,47,47,178,180,185,185,178,185,47,47,
  47,47,47,47,47,47,255,3,8,47,47,179,185,47,47,175,186,47,47,255,3,8,47,47,
  178,183,188,188,178,178,186,186,255,3,8,47,47,178,180,182,185,180,186,47,47,
  255,3,11,47,47,179,183,47,47,179,185,186,47,47,47,47,255,3,12,47,47,179,178,
  182,185,180,180,179,180,180,185,47,47,255,3,14,47,47,179,181,181,180,178,175,
  180,180,180,181,183,47,47,47,255,3,15,47,47,186,179,180,182,182,180,178,177,
  177,178,179,179,184,47,47,255,4,13,47,47,186,182,184,47,47,185,185,183,186,
  47,47,47,47,255,5,9,47,47,47,47,47,47,47,47,47,47,47,255,5,7,47,47,47,186,
  185,186,186,47,47,255,4,9,47,47,187,185,182,181,181,182,185,47,47,255,4,12,
  47,47,183,182,180,182,182,181,182,185,47,47,47,47,255,3,14,47,47,181,180,178,
  175,177,175,178,180,180,182,185,186,47,47,255,3,13,47,47,181,179,185,185,182,
  182,186,186,185,187,187,47,47,255,3,13,47,47,182,186,188,47,181,186,47,47,
  180,184,47,74,74,255,3,14,47,47,180,186,186,47,181,180,186,47,180,181,183,
  187,47,47,255,3,13,47,47,177,178,181,185,181,185,187,47,180,184,47,47,47,255,
  3,13,47,47,181,186,186,47,177,178,180,185,179,186,47,47,47,255,3,14,47,47,
  181,179,182,185,179,185,186,47,181,184,183,187,47,47,255,3,13,47,47,180,185,
  188,47,185,186,47,47,183,187,187,47,47,255,3,12,47,47,183,186,45,47,185,187,
  47,47,188,188,47,47,255,3,11,47,47,47,47,47,47,47,47,47,47,47,47,47,255,255,
  0,9,47,47,47,47,47,47,47,47,47,47,47,10,4,47,47,47,47,47,47,255,0,16,47,47,
  178,179,179,181,181,183,184,47,47,186,181,47,180,47,47,47,255,0,16,47,47,175,
  177,177,178,178,178,180,185,47,181,178,186,47,182,47,47,255,0,16,47,47,178,
  180,180,179,178,179,182,185,47,181,185,47,186,184,47,47,255,0,16,47,47,178,
  180,182,180,180,183,185,47,47,186,181,47,180,47,47,47,255,0,9,47,47,47,47,47,
  47,47,47,47,47,47,10,4,47,47,47,47,47,47,255,0,
};

static const char wiminus[] = {   // status bar widget minus sign
  6,0,3,0,0,0,251,255,32,0,0,0,40,0,0,0,48,0,0,0,56,0,0,0,64,0,0,0,72,0,0,0,0,
  3,191,191,191,191,191,255,0,3,191,191,180,191,191,255,0,3,191,191,180,191,
  191,255,0,3,191,191,178,191,191,255,0,3,191,191,177,191,191,255,0,3,191,191,
  191,191,191,255,
};

static const char dsgetpow[] = {  // sound for getting powerup
  3,0,17,43,248,30,0,0,130,130,130,130,130,130,130,130,130,130,130,130,130,130,
  130,130,130,130,130,130,130,130,130,130,129,129,128,128,127,127,127,126,126,
  125,124,124,123,122,122,121,120,119,118,118,119,120,120,121,122,122,123,123,
  123,123,123,123,124,124,124,124,124,124,124,124,124,125,126,127,128,128,129,
  130,131,132,132,133,134,135,136,137,137,137,137,137,137,137,137,136,136,136,
  135,135,135,135,136,135,135,135,134,134,134,133,133,133,132,132,132,133,134,
  135,136,136,136,136,135,133,132,130,129,128,126,125,124,123,122,121,120,119,
  118,118,119,120,122,125,128,131,133,135,138,139,140,141,142,142,142,141,141,
  140,138,135,133,131,129,126,124,122,120,118,116,115,114,113,113,113,114,115,
  117,119,121,122,123,124,124,124,123,122,121,120,119,118,117,117,117,118,118,
  119,121,122,122,123,124,124,124,124,123,123,122,122,122,122,122,123,123,124,
  125,126,127,128,130,131,133,134,136,138,140,141,143,144,145,145,146,146,146,
  145,144,143,142,140,139,136,134,132,130,128,126,125,124,124,124,124,124,125,
  125,126,126,127,127,126,126,125,124,124,124,125,126,128,129,131,133,135,136,
  137,138,138,138,138,137,135,133,132,131,130,130,129,129,129,129,130,130,130,
  130,129,129,128,127,126,125,124,123,122,121,121,120,120,119,118,118,117,116,
  115,114,113,112,112,111,110,110,109,109,108,108,109,110,111,113,114,115,117,
  117,117,116,116,116,116,117,118,119,120,120,121,121,122,122,123,124,125,125,
  126,126,127,128,131,133,136,139,142,145,148,151,153,154,154,154,153,151,150,
  148,147,146,145,145,145,144,142,140,138,136,133,131,130,129,129,128,127,127,
  128,128,130,132,134,135,137,138,138,139,139,139,138,137,136,134,132,130,128,
  127,126,126,125,126,127,128,130,132,134,135,136,138,139,139,140,140,140,140,
  140,140,139,138,136,134,132,130,127,124,120,116,113,110,107,105,103,102,102,
  103,104,107,110,113,115,117,118,117,116,115,113,111,109,107,106,106,106,107,
  108,108,109,110,111,112,113,115,117,118,119,120,121,122,122,123,125,126,127,
  128,129,129,130,132,133,135,136,137,138,139,141,144,147,150,153,155,157,157,
  157,157,156,155,152,150,147,144,140,137,134,132,131,130,130,130,130,131,131,
  132,133,134,135,136,136,135,134,132,131,128,126,125,125,127,129,131,133,135,
  135,135,134,132,131,130,129,128,128,127,127,127,127,129,131,134,137,140,142,
  143,144,144,143,142,140,138,135,131,127,123,120,116,113,110,108,105,102,99,
  96,93,91,90,90,91,93,97,100,105,108,111,113,114,114,114,115,115,116,116,116,
  115,113,111,110,108,108,107,108,108,108,109,110,111,112,113,113,114,115,116,
  118,120,123,126,131,136,142,148,153,158,162,165,166,167,166,165,164,162,161,
  160,159,158,156,155,153,153,152,150,148,145,140,136,132,130,129,129,128,127,
  126,125,125,126,128,130,133,135,136,136,136,136,136,135,135,135,135,135,136,
  137,139,140,141,141,140,138,135,134,135,137,139,140,141,140,139,137,136,137,
  137,138,138,139,138,138,136,133,129,124,120,116,111,106,103,100,98,96,96,97,
  98,100,102,103,104,105,105,106,106,106,106,105,105,104,103,103,102,102,103,
  103,103,102,101,100,99,100,102,106,109,113,116,120,123,126,128,130,131,130,
  129,129,129,131,133,134,135,136,138,139,142,146,151,157,163,167,169,168,166,
  164,161,160,159,158,157,155,152,148,145,142,140,138,137,136,134,133,133,133,
  134,136,137,137,137,136,135,134,133,132,131,130,130,131,132,134,135,136,135,
  132,128,123,119,116,116,118,120,123,124,125,126,127,128,131,135,139,141,143,
  144,144,143,142,140,138,135,132,129,125,121,117,112,108,105,101,98,95,91,87,
  82,79,78,80,85,92,101,110,117,122,125,127,127,127,128,128,128,128,127,124,
  121,119,116,114,111,108,105,103,102,103,106,109,111,113,115,118,121,124,128,
  131,134,136,139,142,146,150,154,157,159,159,157,154,151,150,151,153,156,159,
  160,161,160,159,159,161,162,164,165,163,159,153,147,142,137,133,130,128,126,
  124,122,120,118,116,114,112,110,110,110,111,113,114,117,120,124,128,133,138,
  142,145,146,145,142,138,135,133,132,133,134,134,132,129,126,123,120,119,119,
  119,121,122,125,127,128,127,124,120,118,116,115,114,112,111,109,108,107,107,
  108,110,111,111,111,110,110,110,111,113,115,118,120,121,120,119,118,118,119,
  119,119,117,113,109,105,102,99,97,96,98,102,107,113,119,124,126,127,128,128,
  128,128,128,130,133,137,141,146,151,156,159,162,165,168,170,173,173,171,167,
  162,157,154,152,152,152,151,150,148,144,139,135,133,132,133,135,136,135,132,
  129,126,126,127,129,130,130,128,126,124,123,123,123,124,124,124,123,124,124,
  123,121,118,114,112,111,113,115,117,119,121,124,127,129,132,135,139,143,146,
  148,147,145,141,138,136,136,137,137,136,132,126,119,112,105,99,96,94,91,88,
  86,85,85,87,92,100,110,120,127,132,134,134,133,132,132,133,133,132,130,127,
  122,115,108,102,97,94,94,94,95,95,94,94,95,97,102,108,114,122,129,137,144,
  149,153,157,159,162,165,168,171,173,173,171,168,164,161,158,156,155,153,151,
  150,149,147,145,144,143,144,145,146,146,144,139,135,132,131,132,134,135,135,
  133,129,125,121,119,118,118,118,117,115,112,110,110,113,118,125,131,136,137,
  136,133,131,130,129,127,124,122,122,124,126,127,127,125,122,120,121,124,131,
  137,143,145,145,143,138,133,129,126,126,126,126,124,120,117,113,110,108,106,
  106,106,107,107,105,103,103,104,106,109,112,115,117,119,118,117,116,116,118,
  120,121,121,118,114,108,104,102,104,109,114,119,125,128,130,131,131,130,129,
  127,126,127,129,133,137,141,143,143,143,144,145,147,150,154,156,156,154,151,
  148,148,150,155,161,164,165,164,162,160,159,157,156,156,154,150,144,137,129,
  123,119,117,115,114,112,109,106,104,103,103,104,106,109,113,119,125,131,135,
  136,135,133,131,131,132,135,137,139,138,136,133,132,133,135,136,135,133,131,
  127,123,119,117,118,120,123,126,130,132,132,130,127,124,123,121,121,121,122,
  120,115,107,101,99,103,111,120,126,127,124,118,114,113,115,119,122,124,124,
  122,119,114,111,108,107,107,106,105,102,99,97,97,99,99,99,99,102,109,117,125,
  131,135,138,140,143,146,150,154,157,159,159,158,157,157,157,159,159,159,159,
  157,156,156,155,152,149,148,148,149,149,147,144,140,137,135,133,131,130,129,
  129,128,127,125,122,120,119,121,124,125,124,122,120,119,119,121,124,128,131,
  134,134,132,128,123,118,115,114,115,117,120,122,122,119,115,114,116,123,131,
  139,145,149,151,153,152,148,141,135,131,132,134,137,138,136,133,129,126,122,
  119,115,113,112,110,108,105,102,100,99,100,104,109,115,119,120,119,117,116,
  115,115,114,112,108,106,106,108,108,107,106,107,110,114,117,118,117,114,113,
  115,119,123,127,129,131,132,134,135,138,143,148,153,155,154,152,149,149,150,
  151,151,152,155,157,159,159,158,158,158,157,154,149,145,146,149,152,153,149,
  140,129,121,119,123,127,129,127,123,117,112,109,108,110,112,114,115,115,116,
  118,122,127,131,132,130,128,129,132,136,136,135,134,133,132,128,125,124,125,
  125,124,122,119,118,120,124,129,134,140,144,146,146,146,145,141,136,133,133,
  133,131,126,119,113,109,109,111,113,114,111,107,101,96,92,91,96,103,110,116,
  120,123,126,126,124,121,119,119,119,117,115,113,111,108,105,103,103,105,110,
  117,122,125,126,125,124,124,127,131,133,131,128,128,132,139,145,149,151,150,
  147,145,147,151,158,161,160,157,154,152,152,154,157,159,157,153,149,149,150,
  150,150,149,145,139,129,119,112,109,108,110,113,115,114,111,110,111,115,119,
  123,126,129,131,131,130,127,125,122,121,121,125,131,137,140,138,132,124,120,
  120,125,132,138,141,140,138,135,132,129,126,126,128,132,137,140,142,142,142,
  141,138,132,123,117,115,116,118,117,115,112,111,111,111,111,112,113,115,116,
  117,116,113,109,106,104,104,105,105,105,105,106,110,114,118,121,121,117,107,
  98,94,97,105,112,116,117,118,121,126,131,135,138,141,145,147,148,145,143,141,
  140,140,141,145,150,155,161,166,170,169,163,157,153,152,153,156,157,158,155,
  149,141,133,128,128,129,130,130,128,127,126,126,124,120,117,117,118,117,112,
  109,109,115,123,130,134,132,129,129,133,139,141,139,134,127,122,119,119,119,
  117,115,112,110,110,113,119,127,134,138,140,141,141,142,143,144,145,147,151,
  156,159,158,152,144,136,131,128,125,119,111,104,99,95,89,82,77,77,82,90,100,
  110,120,127,131,131,130,127,124,120,119,120,121,122,120,116,111,106,103,104,
  108,113,117,117,115,113,113,117,121,120,116,112,114,118,123,130,136,141,144,
  145,148,154,157,157,155,154,155,157,159,161,161,158,153,149,151,156,162,165,
  164,160,152,144,137,132,128,124,118,115,114,116,119,120,121,122,125,125,121,
  115,112,115,121,126,128,126,120,113,110,112,121,133,142,147,146,141,133,127,
  124,124,126,127,129,129,128,127,129,132,134,135,138,143,147,147,144,142,143,
  147,150,147,138,126,114,109,110,114,118,119,116,113,110,108,107,107,108,110,
  113,113,111,107,105,106,111,117,122,123,121,118,116,117,120,123,124,118,106,
  94,87,88,94,102,106,108,109,111,116,122,127,128,126,126,128,134,140,143,142,
  139,134,132,134,140,148,155,160,162,162,161,159,157,157,155,151,146,144,145,
  149,152,156,158,158,156,153,148,141,137,134,132,129,127,124,119,112,105,100,
  99,103,108,113,118,124,129,132,134,137,140,139,136,133,132,129,123,118,116,
  118,121,123,122,120,117,118,123,131,138,141,140,136,131,128,130,135,140,145,
  149,153,155,154,151,147,140,132,125,119,113,108,106,106,103,96,91,92,97,103,
  109,119,130,138,141,138,131,123,115,110,110,114,118,118,115,112,110,108,106,
  102,98,94,94,96,97,96,95,97,102,109,115,118,120,123,129,137,146,151,152,150,
  149,151,153,152,149,146,144,143,145,150,155,157,156,154,150,147,149,156,165,
  168,165,156,147,140,136,134,132,128,126,126,129,133,137,139,137,131,122,114,
  110,109,109,111,115,118,118,114,109,110,116,127,140,152,159,158,149,136,125,
  119,117,116,113,109,106,106,112,122,132,138,142,145,146,144,143,144,148,151,
  154,156,153,143,133,129,130,130,128,127,128,127,125,121,116,107,96,89,89,93,
  96,96,98,104,112,118,120,119,118,118,120,122,123,122,121,117,109,100,96,97,
  101,104,105,107,110,114,120,129,136,136,126,113,107,110,117,125,133,136,134,
  128,127,133,140,143,145,148,151,152,151,151,152,149,143,139,139,143,150,161,
  171,178,183,182,177,167,157,148,140,136,136,136,133,126,115,105,98,96,97,98,
  101,105,112,120,127,133,135,136,135,133,131,131,130,127,125,126,131,136,140,
  140,135,126,121,121,125,129,130,129,124,117,113,115,119,124,132,142,153,162,
  165,164,157,148,139,134,131,126,117,107,100,100,103,108,111,112,112,112,115,
  121,129,135,138,136,129,120,112,107,106,111,117,123,125,125,122,115,105,95,
  90,90,93,93,90,86,85,90,98,108,115,120,123,128,136,145,150,150,146,144,143,
  142,141,137,132,125,121,125,134,144,149,148,147,147,149,154,159,164,164,159,
  151,147,150,156,160,157,149,139,133,134,139,146,151,152,146,135,124,115,108,
  103,100,102,107,110,109,106,108,115,126,139,147,150,149,145,141,136,129,122,
  112,105,102,104,110,119,129,137,140,139,140,144,147,149,147,142,134,129,129,
  133,134,134,133,133,133,134,136,139,141,141,140,138,129,115,102,98,101,105,
  105,105,109,116,123,129,135,139,134,122,108,102,102,105,104,102,98,94,91,90,
  92,95,101,109,116,120,121,124,125,123,119,116,115,116,119,125,130,132,133,
  136,140,140,134,128,128,133,139,142,143,142,138,132,128,129,134,141,149,160,
  173,185,192,193,189,181,169,158,150,147,146,143,138,128,114,104,103,110,113,
  108,102,103,111,118,124,127,127,124,120,117,115,115,119,129,140,149,153,154,
  150,144,137,133,130,128,124,121,119,116,112,106,101,101,106,116,127,136,144,
  152,157,157,152,145,144,147,146,136,122,112,111,117,128,137,141,138,132,129,
  130,130,126,120,116,114,110,104,97,94,94,98,105,115,121,123,122,120,117,112,
  108,103,99,95,93,93,98,106,117,125,129,127,125,127,135,141,139,132,123,118,
  116,114,114,113,111,110,112,120,127,131,135,141,147,149,149,151,156,161,163,
  162,160,158,159,163,166,164,159,156,155,156,155,152,146,141,136,132,126,114,
  99,86,81,83,90,101,114,128,139,143,141,139,139,143,148,152,153,147,136,123,
  114,111,112,113,114,118,123,127,129,129,128,130,133,133,129,123,119,119,123,
  128,135,142,146,148,151,157,160,159,155,152,147,139,127,118,114,112,107,102,
  102,107,113,123,135,144,142,131,119,111,109,109,108,106,104,102,100,99,101,
  107,115,121,122,118,113,112,115,119,121,118,106,90,77,77,87,102,118,130,138,
  140,136,128,123,127,135,140,139,138,137,136,136,138,141,139,135,132,137,149,
  164,176,179,176,169,159,148,140,138,141,146,145,134,120,115,122,136,145,145,
  138,132,129,128,128,127,127,126,123,120,115,113,114,119,127,134,139,141,141,
  138,134,129,126,125,122,119,115,113,110,107,106,110,120,132,138,139,140,143,
  148,150,149,146,142,138,134,128,121,118,122,132,143,151,153,150,144,137,132,
  126,122,122,127,130,125,115,107,103,101,103,109,118,125,128,131,135,137,130,
  116,103,96,97,96,92,89,93,101,107,110,114,120,124,125,122,118,115,114,115,
  114,113,113,114,114,114,117,125,133,137,137,139,142,141,136,132,133,137,138,
  134,128,123,125,138,155,164,165,163,162,159,161,168,174,173,163,151,138,127,
  118,113,108,104,105,114,125,134,137,134,128,122,120,123,128,134,140,146,143,
  134,125,123,123,118,113,116,128,139,142,137,132,130,131,131,130,125,116,106,
  98,101,115,135,150,157,155,149,140,136,137,141,144,142,137,132,128,125,124,
  125,127,129,132,139,149,157,154,142,130,124,123,120,112,101,93,91,95,101,108,
  115,118,118,116,115,113,112,110,106,104,104,103,99,93,91,96,102,109,118,128,
  137,142,139,131,125,125,125,121,116,117,124,129,128,123,116,107,103,111,128,
  146,157,159,155,151,148,147,149,150,148,143,138,135,138,151,167,177,176,165,
  151,140,135,134,136,134,126,118,114,113,113,115,119,121,121,121,124,127,129,
  132,137,145,147,142,132,121,114,113,116,118,118,117,121,130,138,140,137,133,
  128,124,123,125,130,134,134,129,121,115,118,130,144,154,158,155,149,145,140,
  134,130,131,134,137,136,133,129,126,119,113,113,122,133,138,140,143,145,138,
  124,111,102,96,91,90,92,98,102,105,107,111,115,119,119,115,107,98,91,91,96,
  103,111,116,120,122,124,126,128,131,134,138,138,136,132,131,131,126,118,110,
  104,101,107,120,136,146,149,150,151,153,158,165,168,167,164,159,153,150,150,
  148,138,128,126,130,137,142,145,145,140,132,124,116,112,116,127,136,136,130,
  124,119,114,112,118,133,149,157,153,140,129,124,127,136,141,135,120,103,91,
  91,104,124,138,140,135,128,125,126,131,136,136,133,130,129,130,131,137,145,
  147,142,136,136,143,155,165,167,160,149,140,132,123,112,105,108,113,114,112,
  114,122,127,123,115,109,103,93,84,82,90,99,100,97,96,97,101,108,117,127,136,
  143,141,134,129,130,130,125,121,120,119,116,111,106,101,96,99,110,122,128,
  125,117,112,115,123,131,137,142,142,137,135,141,153,166,174,177,180,182,178,
  166,157,154,151,142,130,126,128,128,124,120,114,108,106,111,120,129,137,145,
  151,150,144,133,124,120,122,126,127,123,117,115,121,131,140,142,138,126,111,
  100,100,111,127,137,138,134,127,122,120,125,136,147,153,153,148,141,134,133,
  138,143,141,133,126,122,123,128,136,143,146,146,144,139,135,135,140,143,140,
  130,116,104,101,107,113,113,110,109,110,110,109,108,108,109,107,102,95,90,90,
  96,106,115,118,116,111,110,117,129,142,148,145,137,128,122,118,114,108,102,
  97,95,98,104,111,120,128,131,132,135,141,149,151,148,143,142,147,158,167,169,
  165,160,154,147,146,153,160,160,154,148,142,130,118,113,118,122,123,121,121,
  123,125,126,132,139,143,142,138,135,133,131,132,133,131,123,116,114,118,123,
  127,130,127,117,110,112,122,134,142,141,130,117,110,110,118,128,135,136,132,
  130,132,139,148,158,164,159,150,145,143,142,140,138,135,131,125,120,121,128,
  136,140,139,132,118,100,86,84,93,105,112,112,107,99,95,98,107,116,123,130,
  132,129,122,118,119,123,124,119,112,106,102,103,107,110,114,119,122,122,117,
  109,103,105,110,109,105,106,110,116,124,138,152,156,151,147,152,164,176,181,
  178,170,163,155,147,140,135,134,135,135,132,126,120,119,124,132,142,151,155,
  149,138,130,127,130,134,137,139,138,130,119,115,123,136,143,142,131,113,96,
  93,102,115,123,126,124,121,117,116,120,130,140,145,146,145,142,135,133,138,
  147,145,131,118,113,119,131,144,151,150,146,140,135,135,142,150,150,142,129,
  118,114,121,135,146,147,137,124,114,109,107,110,115,122,121,111,96,85,82,86,
  93,100,104,107,106,102,102,113,132,147,148,140,130,118,110,110,117,120,114,
  104,100,102,107,117,125,122,109,99,101,113,127,133,131,126,120,122,132,145,
  155,160,161,156,152,157,166,172,173,172,170,160,149,142,137,131,126,127,129,
  131,131,132,134,135,136,137,137,132,122,114,111,117,126,130,129,129,132,131,
  126,123,124,127,128,127,129,136,141,139,131,122,115,111,112,119,126,127,124,
  124,129,133,134,138,141,137,128,124,125,130,137,142,143,143,144,145,146,145,
  144,144,143,139,135,130,125,122,121,118,112,107,108,111,112,112,111,111,112,
  114,115,115,117,120,121,120,114,105,98,94,98,112,125,127,121,117,117,118,118,
  118,116,112,107,100,91,90,100,113,121,128,134,131,120,114,121,139,156,166,
  165,153,141,138,143,149,154,154,148,139,134,134,139,150,161,164,157,148,143,
  138,134,134,136,134,128,126,129,135,139,143,145,146,141,133,126,123,124,124,
  121,119,120,115,106,101,107,117,122,122,121,121,121,127,141,152,150,138,127,
  123,121,117,115,119,128,140,147,147,142,138,136,134,136,140,143,140,135,134,
  134,133,132,137,145,150,148,140,129,122,123,127,129,130,128,122,112,104,102,
  101,102,102,102,101,101,103,104,109,119,126,127,123,118,112,105,105,112,115,
  111,108,112,121,127,130,127,115,101,96,101,112,123,129,126,115,103,97,100,
  112,128,143,149,145,140,142,149,159,169,174,170,157,146,145,147,145,141,143,
  145,143,137,138,144,149,145,140,137,137,133,126,119,120,127,132,131,132,134,
  133,128,126,130,137,136,129,123,125,131,132,128,126,123,116,107,106,113,119,
  122,128,136,137,132,128,126,124,127,133,133,126,122,127,135,141,146,151,150,
  141,133,133,140,146,144,135,126,123,124,125,126,126,128,129,127,125,125,127,
  132,136,133,126,122,121,119,115,108,103,101,101,102,105,108,109,111,115,121,
  124,124,124,122,117,109,102,102,106,111,112,113,117,121,121,113,107,108,116,
  127,138,143,137,124,117,118,121,127,134,137,135,135,143,154,161,162,157,149,
  142,140,143,149,156,157,148,135,128,131,138,146,154,160,158,148,132,119,116,
  123,130,131,129,127,121,111,106,108,111,114,118,125,128,126,125,133,141,139,
  128,120,121,125,128,128,127,126,128,131,133,137,141,141,138,135,134,134,129,
  123,122,127,130,128,127,131,135,138,139,139,140,142,143,144,144,143,141,140,
  137,129,120,113,112,118,126,132,130,121,111,106,106,107,110,115,114,102,88,
  87,95,101,106,117,131,133,125,118,114,114,118,122,119,113,111,113,112,107,
  104,108,113,114,112,109,111,122,137,147,146,139,134,131,132,139,150,156,153,
  145,141,142,145,146,149,151,149,144,142,142,139,134,131,132,133,133,132,133,
  135,139,142,142,140,139,140,139,135,133,134,133,129,123,115,108,106,108,114,
  121,126,128,128,128,129,132,134,130,127,127,129,126,120,118,123,128,129,134,
  139,138,129,126,128,133,136,141,142,134,124,121,125,129,134,141,142,137,135,
  141,148,150,146,139,132,128,127,126,122,118,114,110,107,107,111,115,116,117,
  120,122,118,112,110,112,115,114,113,114,115,115,116,118,119,118,118,117,112,
  104,102,111,123,127,117,104,97,96,98,108,124,133,131,126,125,131,141,149,153,
  153,149,143,138,137,139,143,148,146,138,129,128,131,138,146,152,153,145,133,
  128,129,133,133,134,136,132,122,116,121,129,136,138,138,131,123,122,130,138,
  135,126,116,112,113,118,125,127,126,126,128,130,133,134,134,132,131,131,129,
  125,124,128,132,131,128,131,133,129,123,124,132,141,145,146,145,136,124,121,
  131,146,155,152,140,127,120,124,137,149,150,140,127,120,118,118,121,123,116,
  102,93,95,102,112,122,128,126,117,112,115,126,137,141,134,119,103,95,96,99,
  100,104,109,111,105,97,98,109,122,130,131,126,117,114,118,127,136,141,139,
  135,132,132,137,145,150,147,138,127,121,124,132,139,140,136,133,130,128,128,
  132,141,151,156,157,155,151,142,133,129,130,136,141,140,134,126,121,119,116,
  116,121,128,128,125,124,128,129,127,123,124,127,128,128,132,133,129,126,125,
  127,128,128,128,133,137,138,138,134,121,110,107,110,118,130,139,138,129,125,
  130,139,146,147,146,143,141,140,140,140,140,138,134,127,119,119,125,132,134,
  132,128,120,114,110,114,120,123,123,121,117,111,110,115,119,119,121,125,122,
  112,106,112,120,117,104,97,98,99,97,99,107,113,116,117,120,128,135,136,133,
  133,135,134,132,131,132,134,134,130,127,123,120,118,119,126,137,143,143,140,
  139,135,131,132,135,137,137,140,144,148,146,143,143,142,137,132,132,136,138,
  136,135,129,119,111,112,119,125,128,127,127,127,128,128,131,137,141,138,130,
  125,125,126,127,129,133,134,128,119,113,119,131,138,137,132,126,121,120,123,
  130,135,139,138,131,124,127,141,154,159,150,137,126,122,128,139,150,151,140,
  125,115,113,120,131,141,143,135,122,116,120,128,134,133,124,110,97,90,90,98,
  109,116,113,102,93,93,99,107,119,132,134,125,114,115,126,134,136,131,125,121,
  119,116,117,122,124,122,120,120,122,123,123,120,117,117,121,125,129,132,131,
  130,134,144,152,156,153,149,145,144,142,144,150,155,149,137,128,126,128,128,
  129,130,127,122,122,124,127,126,126,124,121,120,125,134,139,136,128,126,129,
  133,133,133,134,133,131,130,128,128,127,122,115,110,114,122,124,123,126,130,
  129,124,120,122,127,133,141,146,144,137,136,137,136,132,133,139,141,138,138,
  143,146,142,139,137,133,127,123,123,125,126,127,128,124,116,112,116,122,123,
  120,115,108,100,100,108,113,114,116,119,116,108,103,107,116,123,125,125,128,
  131,130,126,121,119,116,116,118,120,120,115,108,106,113,123,128,127,125,124,
  124,126,134,142,140,132,128,135,143,148,151,154,154,145,132,125,130,136,141,
  144,148,146,136,125,121,122,123,121,122,123,127,132,139,144,146,141,132,123,
  121,128,136,140,138,132,125,119,114,116,123,131,134,130,120,110,108,116,126,
  133,135,131,125,120,121,132,143,143,132,120,116,122,135,151,162,164,152,137,
  128,126,130,139,146,148,142,130,122,124,131,139,138,133,127,119,110,108,112,
  117,122,124,122,118,115,112,108,108,113,119,117,113,113,120,125,125,124,122,
  119,113,107,106,113,120,122,121,123,123,119,115,117,121,122,117,113,111,114,
  119,121,124,128,131,132,130,129,132,137,138,136,137,141,142,139,135,134,138,
  143,144,140,132,124,124,131,141,147,146,141,135,131,131,131,132,133,131,127,
  124,126,129,131,131,130,128,123,118,118,124,130,132,131,128,124,120,121,127,
  132,132,125,119,118,121,124,128,134,137,137,135,134,132,128,124,124,128,130,
  133,136,138,137,136,136,139,141,139,132,128,131,134,137,139,140,140,135,131,
  130,129,127,125,125,127,127,123,118,116,117,119,117,115,113,113,111,110,111,
  113,119,123,125,124,122,121,119,119,119,117,110,102,102,110,118,123,125,125,
  120,113,110,111,116,122,125,128,130,133,133,130,129,129,129,129,130,133,136,
  137,139,144,150,152,145,136,133,136,136,135,135,135,133,133,136,140,139,137,
  133,125,121,125,132,136,135,130,128,124,123,126,132,135,133,126,120,119,126,
  135,137,131,124,120,118,118,122,130,133,128,118,112,113,121,130,138,143,141,
  136,133,131,132,132,131,130,130,130,130,135,142,145,140,132,127,125,126,130,
  135,142,146,144,138,132,129,127,123,118,118,122,123,120,121,125,126,124,120,
  116,113,111,111,114,115,113,108,104,105,111,118,123,125,126,123,116,109,109,
  115,123,130,134,130,122,116,116,118,120,124,128,130,130,130,129,126,122,121,
  121,122,124,127,130,133,139,145,146,143,140,138,138,141,146,152,152,146,132,
  119,114,121,132,144,150,148,136,123,114,112,118,129,139,141,135,126,121,121,
  125,130,133,128,119,114,119,124,127,128,130,132,132,132,132,130,125,122,125,
  128,126,123,121,124,129,135,138,137,130,121,117,121,131,140,145,146,145,142,
  140,139,136,131,127,129,136,146,150,144,133,123,117,115,116,122,128,128,123,
  117,117,120,121,118,116,115,115,117,122,125,124,117,108,100,101,110,123,132,
  135,129,120,115,114,115,115,115,118,121,122,124,128,126,118,109,108,112,118,
  124,128,129,129,131,135,137,135,133,135,138,139,137,136,137,139,141,141,139,
  137,135,135,133,133,134,135,134,128,125,128,133,135,133,133,129,122,118,121,
  130,138,141,140,133,122,118,124,131,132,128,123,118,116,119,126,130,129,130,
  129,125,120,122,131,140,140,133,124,115,112,119,133,144,144,136,127,122,122,
  126,131,135,137,136,136,137,138,139,138,136,136,137,136,133,129,130,134,134,
  129,125,124,121,116,115,121,124,121,113,109,110,112,114,117,121,124,127,124,
  118,114,116,125,133,132,127,122,120,119,119,122,126,126,121,116,114,116,118,
  119,119,119,117,114,111,111,117,128,137,141,141,136,131,129,132,139,148,151,
  145,137,132,132,132,134,136,136,132,126,124,130,139,142,137,129,125,123,123,
  126,133,139,137,129,122,121,125,128,129,128,126,126,128,129,129,128,124,122,
  123,128,132,133,132,129,124,121,121,123,124,125,128,131,134,134,129,124,121,
  123,131,140,144,140,131,125,126,132,140,144,144,139,133,130,133,137,135,128,
  123,120,121,128,137,140,133,123,117,116,118,123,129,133,131,126,119,116,117,
  119,119,118,119,122,126,126,122,117,115,114,117,122,124,122,116,110,109,113,
  119,123,122,120,121,123,123,123,125,127,125,120,118,120,126,131,135,139,139,
  136,130,127,129,132,134,137,142,142,134,126,123,127,132,136,138,135,129,123,
  122,126,132,138,140,137,134,135,136,134,130,128,126,123,121,124,127,128,127,
  127,126,122,120,122,128,136,141,138,130,124,123,128,131,132,129,126,125,125,
  124,123,124,128,131,133,131,128,126,126,130,132,135,138,139,136,133,133,136,
  139,139,137,134,128,122,121,125,130,134,133,129,125,123,124,124,125,128,129,
  130,128,125,121,119,122,129,131,126,116,110,110,114,117,120,123,124,122,120,
  119,120,121,121,121,121,119,115,114,117,121,126,126,124,120,120,123,129,135,
  136,130,124,123,129,135,134,129,126,124,123,125,132,138,140,139,137,133,129,
  129,136,141,139,132,125,123,124,127,132,134,132,128,123,122,127,134,135,130,
  125,126,128,128,128,129,128,128,129,131,130,127,125,126,130,132,131,128,124,
  123,125,130,134,134,129,124,121,122,125,130,133,132,129,125,126,129,133,136,
  138,134,127,124,128,135,140,141,137,132,129,129,131,132,134,136,136,132,130,
  130,129,125,123,124,124,122,122,120,117,117,123,130,130,125,121,118,114,112,
  115,120,123,121,118,117,117,118,121,125,128,126,122,119,119,121,123,123,123,
  121,118,117,118,123,127,130,132,133,132,128,124,124,129,134,135,132,129,126,
  124,127,134,140,140,137,136,135,132,130,132,135,134,129,124,123,126,130,133,
  131,128,124,123,125,128,133,138,137,134,134,134,132,129,130,133,134,131,126,
  121,119,119,120,124,127,129,128,126,124,124,125,127,129,133,136,137,133,128,
  127,129,133,135,134,131,128,129,131,131,128,126,128,130,131,131,132,133,133,
  134,133,132,130,130,132,133,133,130,127,123,121,120,121,122,124,125,123,121,
  121,122,120,118,120,126,128,123,116,112,115,121,127,127,124,120,118,119,124,
  126,124,120,119,120,123,128,132,131,126,120,117,118,122,127,131,132,129,127,
  126,126,129,133,134,129,124,126,133,136,133,128,127,128,129,130,132,134,136,
  137,135,133,132,130,128,128,130,132,132,128,123,120,120,125,133,138,137,133,
  127,123,122,126,131,134,134,131,125,122,123,127,130,130,127,123,122,126,131,
  132,129,128,128,127,126,126,130,134,135,134,134,133,128,123,122,127,134,142,
  145,144,138,130,125,124,128,132,135,135,131,127,125,126,130,131,127,120,117,
  120,127,131,129,123,119,120,123,125,126,127,128,127,126,125,124,121,118,117,
  119,121,121,120,118,116,115,116,119,121,121,119,117,120,124,128,128,128,125,
  122,120,122,130,138,141,136,130,126,126,128,131,135,136,132,127,124,126,128,
  127,126,128,132,133,133,130,128,125,126,129,131,132,134,137,139,138,135,131,
  128,126,127,129,130,130,128,127,127,127,126,125,124,126,129,132,132,129,126,
  125,124,125,126,128,128,127,128,132,133,130,124,121,122,126,130,135,138,136,
  132,128,124,124,128,134,138,138,136,133,130,127,127,128,131,134,135,134,131,
  126,123,122,125,130,134,136,134,128,123,119,120,122,123,122,120,117,117,122,
  128,127,121,114,111,112,116,122,128,131,130,125,120,121,126,129,128,126,124,
  123,123,124,126,127,124,120,118,120,122,124,126,128,128,127,125,124,125,129,
  133,135,136,137,137,134,131,131,132,132,130,130,131,130,129,129,132,134,132,
  127,121,121,126,134,138,137,132,126,124,126,128,128,128,127,127,127,128,129,
  131,130,129,129,130,132,131,128,125,126,127,128,128,128,129,127,123,122,125,
  127,128,129,130,131,131,132,136,139,138,134,129,126,128,132,135,134,132,130,
  128,126,127,128,130,132,134,135,132,127,126,126,125,126,126,126,124,124,125,
  128,126,121,116,113,113,116,122,127,129,128,124,120,116,116,119,125,130,131,
  129,124,121,122,124,123,122,121,123,123,122,122,124,124,123,123,124,126,127,
  127,128,130,129,127,126,129,132,137,138,136,132,130,131,130,129,129,132,133,
  133,133,133,131,127,125,126,127,127,127,129,131,132,132,130,128,128,129,129,
  129,129,131,132,130,127,123,121,120,120,125,131,135,133,129,126,125,126,128,
  129,129,128,127,128,129,131,132,128,125,124,125,127,128,130,133,135,134,130,
  127,127,130,132,133,134,135,134,131,128,128,129,131,132,133,131,128,123,121,
  123,128,129,126,119,117,120,124,126,125,124,121,119,121,126,130,131,128,123,
  120,119,120,122,126,128,128,126,122,120,120,122,123,122,122,122,123,125,124,
  122,122,125,127,128,128,129,131,131,131,132,132,131,128,124,124,129,135,136,
  134,130,127,127,128,131,134,134,131,128,127,128,128,128,128,128,128,128,128,
  129,131,131,129,128,129,130,129,128,128,128,130,131,130,128,125,125,125,126,
  127,128,130,128,124,123,126,130,132,131,130,129,128,127,126,126,127,128,127,
  127,129,131,132,132,132,132,130,130,133,136,135,131,128,128,130,132,132,130,
  128,127,126,126,126,127,127,125,123,122,122,124,124,123,122,124,126,127,126,
  125,125,126,124,123,124,126,126,124,124,124,124,125,125,124,123,121,122,123,
  124,124,123,122,121,121,122,125,128,130,129,126,126,127,128,128,129,132,133,
  133,132,130,130,129,130,131,131,131,130,129,127,126,126,129,133,136,134,131,
  127,125,126,127,128,129,128,126,124,125,128,131,133,130,126,123,124,129,133,
  134,132,130,128,126,124,124,126,128,129,129,127,125,126,128,129,128,128,129,
  130,129,126,125,126,128,130,131,132,132,130,129,129,130,132,132,131,128,127,
  130,133,133,131,128,127,127,128,130,130,129,127,126,125,125,127,129,129,128,
  125,123,123,124,127,127,125,124,124,123,122,123,125,127,126,123,121,121,120,
  119,121,124,128,129,129,127,124,123,125,128,128,127,125,124,124,126,129,130,
  128,126,123,123,125,130,134,135,134,130,126,125,128,131,132,130,127,127,127,
  128,129,131,131,129,127,127,128,130,130,130,130,130,129,128,127,126,126,128,
  130,131,129,127,126,127,127,127,128,130,130,128,128,128,127,126,126,128,129,
  127,125,124,124,126,127,128,130,132,133,132,130,128,125,125,128,131,133,133,
  133,132,130,130,130,129,129,130,132,131,129,127,126,127,128,128,126,125,125,
  126,127,128,128,128,127,124,123,124,124,123,123,125,128,129,127,123,121,122,
  125,127,127,127,128,127,125,124,125,127,127,126,124,124,123,124,126,127,128,
  126,124,123,125,127,128,127,126,127,127,127,128,130,131,130,130,130,131,130,
  129,128,128,129,131,131,128,126,127,127,126,126,127,128,128,127,129,131,131,
  131,130,128,126,125,126,128,130,130,128,125,124,125,127,129,130,130,129,129,
  128,128,127,126,126,127,129,131,132,130,127,124,124,125,127,129,130,130,129,
  128,128,129,131,131,129,126,126,128,131,133,133,131,128,127,128,129,130,130,
  129,128,128,129,129,128,126,125,125,127,129,129,127,125,124,123,122,124,127,
  130,130,128,126,125,124,124,124,125,126,127,127,128,128,127,125,123,122,123,
  125,126,124,123,123,123,124,125,126,127,128,129,129,129,128,127,127,128,129,
  130,130,130,130,129,128,128,128,127,127,128,128,127,128,129,130,129,128,127,
  126,125,125,126,128,130,130,130,129,128,128,128,129,129,129,129,129,129,128,
  127,127,127,128,128,128,128,128,127,126,126,127,128,128,128,128,127,127,128,
  129,129,128,127,127,128,129,130,131,131,131,130,129,128,128,127,128,129,130,
  129,128,128,127,127,127,129,130,130,128,128,128,127,126,125,126,127,128,128,
  128,127,126,126,126,125,125,125,127,128,129,129,127,125,123,123,124,125,127,
  127,127,126,125,125,125,125,126,126,126,127,128,128,126,126,126,127,128,129,
  129,128,128,127,128,128,129,129,128,126,126,127,127,128,128,128,128,127,127,
  128,129,129,129,129,129,129,129,128,126,126,127,128,128,129,129,129,127,126,
  126,128,129,130,130,129,128,127,126,127,128,128,128,128,127,127,127,127,127,
  126,127,128,128,128,128,127,127,128,129,129,128,126,126,127,128,130,130,130,
  129,128,128,128,128,129,130,130,129,128,128,128,127,128,128,128,128,128,129,
  128,128,127,126,126,126,127,128,128,128,128,127,126,126,126,127,127,127,128,
  128,127,126,126,126,126,126,126,127,126,126,126,126,126,126,125,125,126,126,
  127,128,128,128,126,126,126,127,128,128,129,128,128,128,128,128,129,128,128,
  127,127,128,128,128,127,127,126,126,127,128,128,129,128,128,128,127,127,127,
  128,129,129,129,128,128,128,127,127,128,129,130,130,129,128,127,127,128,128,
  128,128,127,126,127,127,127,127,128,128,128,127,127,128,128,128,128,128,128,
  128,128,128,128,128,128,128,128,128,128,128,128,127,128,129,129,129,129,128,
  127,127,127,128,128,128,128,128,127,127,127,127,128,127,128,128,127,127,127,
  127,127,127,127,127,127,127,126,127,127,127,127,127,127,126,126,127,128,128,
  128,127,126,126,126,126,126,126,126,126,126,126,126,126,126,126,126,126,126,
  126,
};

